/* A Bison parser, made by GNU Bison 2.4.2.  */

/* Skeleton implementation for Bison's Yacc-like parsers in C
   
      Copyright (C) 1984, 1989-1990, 2000-2006, 2009-2010 Free Software
   Foundation, Inc.
   
   This program is free software: you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation, either version 3 of the License, or
   (at your option) any later version.
   
   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.
   
   You should have received a copy of the GNU General Public License
   along with this program.  If not, see <http://www.gnu.org/licenses/>.  */

/* As a special exception, you may create a larger work that contains
   part or all of the Bison parser skeleton and distribute that work
   under terms of your choice, so long as that work isn't itself a
   parser generator using the skeleton or a modified version thereof
   as a parser skeleton.  Alternatively, if you modify or redistribute
   the parser skeleton itself, you may (at your option) remove this
   special exception, which will cause the skeleton and the resulting
   Bison output files to be licensed under the GNU General Public
   License without this special exception.
   
   This special exception was added by the Free Software Foundation in
   version 2.2 of Bison.  */

/* C LALR(1) parser skeleton written by Richard Stallman, by
   simplifying the original so-called "semantic" parser.  */

/* All symbols defined below should begin with yy or YY, to avoid
   infringing on user name space.  This should be done even for local
   variables, as they might otherwise be expanded by user macros.
   There are some unavoidable exceptions within include files to
   define necessary library symbols; they are noted "INFRINGES ON
   USER NAME SPACE" below.  */

/* Identify Bison output.  */
#define YYBISON 1

/* Bison version.  */
#define YYBISON_VERSION "2.4.2"

/* Skeleton name.  */
#define YYSKELETON_NAME "yacc.c"

/* Pure parsers.  */
#define YYPURE 0

/* Push parsers.  */
#define YYPUSH 0

/* Pull parsers.  */
#define YYPULL 1

/* Using locations.  */
#define YYLSP_NEEDED 1

/* Substitute the variable and function names.  */
#define yyparse         hlsl_parse
#define yylex           hlsl_lex
#define yyerror         hlsl_error
#define yylval          hlsl_lval
#define yychar          hlsl_char
#define yydebug         hlsl_debug
#define yynerrs         hlsl_nerrs
#define yylloc          hlsl_lloc

/* Copy the first part of user declarations.  */

/* Line 189 of yacc.c  */
#line 21 "hlsl.y"

#include "config.h"
#include "wine/debug.h"

#include <stdio.h>

#include "d3dcompiler_private.h"

WINE_DEFAULT_DEBUG_CHANNEL(hlsl_parser);

int hlsl_lex(void);

struct hlsl_parse_ctx hlsl_ctx;

struct YYLTYPE;
static void set_location(struct source_location *loc, const struct YYLTYPE *l);

void hlsl_message(const char *fmt, ...)
{
    va_list args;

    va_start(args, fmt);
    compilation_message(&hlsl_ctx.messages, fmt, args);
    va_end(args);
}

static const char *hlsl_get_error_level_name(enum hlsl_error_level level)
{
    const char *names[] =
    {
        "error",
        "warning",
        "note",
    };
    return names[level];
}

void hlsl_report_message(const char *filename, DWORD line, DWORD column,
        enum hlsl_error_level level, const char *fmt, ...)
{
    va_list args;
    char *string = NULL;
    int rc, size = 0;

    while (1)
    {
        va_start(args, fmt);
        rc = vsnprintf(string, size, fmt, args);
        va_end(args);

        if (rc >= 0 && rc < size)
            break;

        if (rc >= size)
            size = rc + 1;
        else
            size = size ? size * 2 : 32;

        if (!string)
            string = d3dcompiler_alloc(size);
        else
            string = d3dcompiler_realloc(string, size);
        if (!string)
        {
            ERR("Error reallocating memory for a string.\n");
            return;
        }
    }

    hlsl_message("%s:%u:%u: %s: %s\n", filename, line, column, hlsl_get_error_level_name(level), string);
    d3dcompiler_free(string);

    if (level == HLSL_LEVEL_ERROR)
        set_parse_status(&hlsl_ctx.status, PARSE_ERR);
    else if (level == HLSL_LEVEL_WARNING)
        set_parse_status(&hlsl_ctx.status, PARSE_WARN);
}

static void hlsl_error(const char *s)
{
    hlsl_report_message(hlsl_ctx.source_file, hlsl_ctx.line_no, hlsl_ctx.column, HLSL_LEVEL_ERROR, "%s", s);
}

static void debug_dump_decl(struct hlsl_type *type, DWORD modifiers, const char *declname, unsigned int line_no)
{
    TRACE("Line %u: ", line_no);
    if (modifiers)
        TRACE("%s ", debug_modifiers(modifiers));
    TRACE("%s %s;\n", debug_hlsl_type(type), declname);
}

static void check_invalid_matrix_modifiers(DWORD modifiers, struct source_location *loc)
{
    if (modifiers & (HLSL_MODIFIER_ROW_MAJOR | HLSL_MODIFIER_COLUMN_MAJOR))
    {
        hlsl_report_message(loc->file, loc->line, loc->col, HLSL_LEVEL_ERROR,
                "'row_major' or 'column_major' modifiers are only allowed for matrices");
    }
}

static BOOL declare_variable(struct hlsl_ir_var *decl, BOOL local)
{
    BOOL ret;

    TRACE("Declaring variable %s.\n", decl->name);
    if (decl->node.data_type->type == HLSL_CLASS_MATRIX)
    {
        if (!(decl->modifiers & (HLSL_MODIFIER_ROW_MAJOR | HLSL_MODIFIER_COLUMN_MAJOR)))
        {
            decl->modifiers |= hlsl_ctx.matrix_majority == HLSL_ROW_MAJOR
                    ? HLSL_MODIFIER_ROW_MAJOR : HLSL_MODIFIER_COLUMN_MAJOR;
        }
    }
    else
        check_invalid_matrix_modifiers(decl->modifiers, &decl->node.loc);

    if (local)
    {
        DWORD invalid = decl->modifiers & (HLSL_STORAGE_EXTERN | HLSL_STORAGE_SHARED
                | HLSL_STORAGE_GROUPSHARED | HLSL_STORAGE_UNIFORM);
        if (invalid)
        {
            hlsl_report_message(decl->node.loc.file, decl->node.loc.line, decl->node.loc.col, HLSL_LEVEL_ERROR,
                    "modifier '%s' invalid for local variables", debug_modifiers(invalid));
        }
        if (decl->semantic)
        {
            hlsl_report_message(decl->node.loc.file, decl->node.loc.line, decl->node.loc.col, HLSL_LEVEL_ERROR,
                    "semantics are not allowed on local variables");
            return FALSE;
        }
    }
    else
    {
        if (find_function(decl->name))
        {
            hlsl_report_message(decl->node.loc.file, decl->node.loc.line, decl->node.loc.col, HLSL_LEVEL_ERROR,
                    "redefinition of '%s'", decl->name);
            return FALSE;
        }
    }
    ret = add_declaration(hlsl_ctx.cur_scope, decl, local);
    if (!ret)
    {
        struct hlsl_ir_var *old = get_variable(hlsl_ctx.cur_scope, decl->name);

        hlsl_report_message(decl->node.loc.file, decl->node.loc.line, decl->node.loc.col, HLSL_LEVEL_ERROR,
                "\"%s\" already declared", decl->name);
        hlsl_report_message(old->node.loc.file, old->node.loc.line, old->node.loc.col, HLSL_LEVEL_NOTE,
                "\"%s\" was previously declared here", old->name);
        return FALSE;
    }
    return TRUE;
}

static DWORD add_modifier(DWORD modifiers, DWORD mod, const struct YYLTYPE *loc);

static BOOL check_type_modifiers(DWORD modifiers, struct source_location *loc)
{
    if (modifiers & ~HLSL_TYPE_MODIFIERS_MASK)
    {
        hlsl_report_message(loc->file, loc->line, loc->col, HLSL_LEVEL_ERROR,
                "modifier not allowed on typedefs");
        return FALSE;
    }
    return TRUE;
}

static BOOL add_type_to_scope(struct hlsl_scope *scope, struct hlsl_type *def)
{
    if (get_type(scope, def->name, FALSE))
        return FALSE;

    wine_rb_put(&scope->types, def->name, &def->scope_entry);
    return TRUE;
}

static void declare_predefined_types(struct hlsl_scope *scope)
{
    struct hlsl_type *type;
    unsigned int x, y, bt;
    static const char *names[] =
    {
        "float",
        "half",
        "double",
        "int",
        "uint",
        "bool",
    };
    char name[10];

    for (bt = 0; bt <= HLSL_TYPE_LAST_SCALAR; ++bt)
    {
        for (y = 1; y <= 4; ++y)
        {
            for (x = 1; x <= 4; ++x)
            {
                sprintf(name, "%s%ux%u", names[bt], x, y);
                type = new_hlsl_type(d3dcompiler_strdup(name), HLSL_CLASS_MATRIX, bt, x, y);
                add_type_to_scope(scope, type);

                if (y == 1)
                {
                    sprintf(name, "%s%u", names[bt], x);
                    type = new_hlsl_type(d3dcompiler_strdup(name), HLSL_CLASS_VECTOR, bt, x, y);
                    add_type_to_scope(scope, type);

                    if (x == 1)
                    {
                        sprintf(name, "%s", names[bt]);
                        type = new_hlsl_type(d3dcompiler_strdup(name), HLSL_CLASS_SCALAR, bt, x, y);
                        add_type_to_scope(scope, type);
                    }
                }
            }
        }
    }

    /* DX8 effects predefined types */
    type = new_hlsl_type(d3dcompiler_strdup("DWORD"), HLSL_CLASS_SCALAR, HLSL_TYPE_INT, 1, 1);
    add_type_to_scope(scope, type);
    type = new_hlsl_type(d3dcompiler_strdup("FLOAT"), HLSL_CLASS_SCALAR, HLSL_TYPE_FLOAT, 1, 1);
    add_type_to_scope(scope, type);
    type = new_hlsl_type(d3dcompiler_strdup("VECTOR"), HLSL_CLASS_VECTOR, HLSL_TYPE_FLOAT, 4, 1);
    add_type_to_scope(scope, type);
    type = new_hlsl_type(d3dcompiler_strdup("MATRIX"), HLSL_CLASS_MATRIX, HLSL_TYPE_FLOAT, 4, 4);
    add_type_to_scope(scope, type);
    type = new_hlsl_type(d3dcompiler_strdup("STRING"), HLSL_CLASS_OBJECT, HLSL_TYPE_STRING, 1, 1);
    add_type_to_scope(scope, type);
    type = new_hlsl_type(d3dcompiler_strdup("TEXTURE"), HLSL_CLASS_OBJECT, HLSL_TYPE_TEXTURE, 1, 1);
    add_type_to_scope(scope, type);
    type = new_hlsl_type(d3dcompiler_strdup("PIXELSHADER"), HLSL_CLASS_OBJECT, HLSL_TYPE_PIXELSHADER, 1, 1);
    add_type_to_scope(scope, type);
    type = new_hlsl_type(d3dcompiler_strdup("VERTEXSHADER"), HLSL_CLASS_OBJECT, HLSL_TYPE_VERTEXSHADER, 1, 1);
    add_type_to_scope(scope, type);
}

static struct hlsl_ir_if *loop_condition(struct list *cond_list)
{
    struct hlsl_ir_if *out_cond;
    struct hlsl_ir_expr *not_cond;
    struct hlsl_ir_node *cond, *operands[3];
    struct hlsl_ir_jump *jump;
    unsigned int count = list_count(cond_list);

    if (!count)
        return NULL;
    if (count != 1)
        ERR("Got multiple expressions in a for condition.\n");

    cond = LIST_ENTRY(list_head(cond_list), struct hlsl_ir_node, entry);
    out_cond = d3dcompiler_alloc(sizeof(*out_cond));
    if (!out_cond)
    {
        ERR("Out of memory.\n");
        return NULL;
    }
    out_cond->node.type = HLSL_IR_IF;
    operands[0] = cond;
    operands[1] = operands[2] = NULL;
    not_cond = new_expr(HLSL_IR_UNOP_LOGIC_NOT, operands, &cond->loc);
    if (!not_cond)
    {
        ERR("Out of memory.\n");
        d3dcompiler_free(out_cond);
        return NULL;
    }
    out_cond->condition = &not_cond->node;
    jump = d3dcompiler_alloc(sizeof(*jump));
    if (!jump)
    {
        ERR("Out of memory.\n");
        d3dcompiler_free(out_cond);
        d3dcompiler_free(not_cond);
        return NULL;
    }
    jump->node.type = HLSL_IR_JUMP;
    jump->type = HLSL_IR_JUMP_BREAK;
    out_cond->then_instrs = d3dcompiler_alloc(sizeof(*out_cond->then_instrs));
    if (!out_cond->then_instrs)
    {
        ERR("Out of memory.\n");
        d3dcompiler_free(out_cond);
        d3dcompiler_free(not_cond);
        d3dcompiler_free(jump);
        return NULL;
    }
    list_init(out_cond->then_instrs);
    list_add_head(out_cond->then_instrs, &jump->node.entry);

    return out_cond;
}

enum loop_type
{
    LOOP_FOR,
    LOOP_WHILE,
    LOOP_DO_WHILE
};

static struct list *create_loop(enum loop_type type, struct list *init, struct list *cond,
        struct hlsl_ir_node *iter, struct list *body, struct source_location *loc)
{
    struct list *list = NULL;
    struct hlsl_ir_loop *loop = NULL;
    struct hlsl_ir_if *cond_jump = NULL;

    list = d3dcompiler_alloc(sizeof(*list));
    if (!list)
        goto oom;
    list_init(list);

    if (init)
        list_move_head(list, init);

    loop = d3dcompiler_alloc(sizeof(*loop));
    if (!loop)
        goto oom;
    loop->node.type = HLSL_IR_LOOP;
    loop->node.loc = *loc;
    list_add_tail(list, &loop->node.entry);
    loop->body = d3dcompiler_alloc(sizeof(*loop->body));
    if (!loop->body)
        goto oom;
    list_init(loop->body);

    cond_jump = loop_condition(cond);
    if (!cond_jump)
        goto oom;

    if (type != LOOP_DO_WHILE)
        list_add_tail(loop->body, &cond_jump->node.entry);

    list_move_tail(loop->body, body);

    if (iter)
        list_add_tail(loop->body, &iter->entry);

    if (type == LOOP_DO_WHILE)
        list_add_tail(loop->body, &cond_jump->node.entry);

    d3dcompiler_free(init);
    d3dcompiler_free(cond);
    d3dcompiler_free(body);
    return list;

oom:
    ERR("Out of memory.\n");
    if (loop)
        d3dcompiler_free(loop->body);
    d3dcompiler_free(loop);
    d3dcompiler_free(cond_jump);
    d3dcompiler_free(list);
    free_instr_list(init);
    free_instr_list(cond);
    free_instr(iter);
    free_instr_list(body);
    return NULL;
}

static unsigned int initializer_size(struct list *initializer)
{
    unsigned int count = 0;
    struct hlsl_ir_node *node;

    LIST_FOR_EACH_ENTRY(node, initializer, struct hlsl_ir_node, entry)
    {
        count += components_count_type(node->data_type);
    }
    TRACE("Initializer size = %u\n", count);
    return count;
}

static unsigned int components_count_expr_list(struct list *list)
{
    struct hlsl_ir_node *node;
    unsigned int count = 0;

    LIST_FOR_EACH_ENTRY(node, list, struct hlsl_ir_node, entry)
    {
        count += components_count_type(node->data_type);
    }
    return count;
}

static struct hlsl_ir_swizzle *new_swizzle(DWORD s, unsigned int components,
        struct hlsl_ir_node *val, struct source_location *loc)
{
    struct hlsl_ir_swizzle *swizzle = d3dcompiler_alloc(sizeof(*swizzle));

    if (!swizzle)
        return NULL;
    swizzle->node.type = HLSL_IR_SWIZZLE;
    swizzle->node.loc = *loc;
    swizzle->node.data_type = new_hlsl_type(NULL, HLSL_CLASS_VECTOR, val->data_type->base_type, components, 1);
    swizzle->val = val;
    swizzle->swizzle = s;
    return swizzle;
}

static struct hlsl_ir_swizzle *get_swizzle(struct hlsl_ir_node *value, const char *swizzle,
        struct source_location *loc)
{
    unsigned int len = strlen(swizzle), component = 0;
    unsigned int i, set, swiz = 0;
    BOOL valid;

    if (value->data_type->type == HLSL_CLASS_MATRIX)
    {
        /* Matrix swizzle */
        BOOL m_swizzle;
        unsigned int inc, x, y;

        if (len < 3 || swizzle[0] != '_')
            return NULL;
        m_swizzle = swizzle[1] == 'm';
        inc = m_swizzle ? 4 : 3;

        if (len % inc || len > inc * 4)
            return NULL;

        for (i = 0; i < len; i += inc)
        {
            if (swizzle[i] != '_')
                return NULL;
            if (m_swizzle)
            {
                if (swizzle[i + 1] != 'm')
                    return NULL;
                x = swizzle[i + 2] - '0';
                y = swizzle[i + 3] - '0';
            }
            else
            {
                x = swizzle[i + 1] - '1';
                y = swizzle[i + 2] - '1';
            }

            if (x >= value->data_type->dimx || y >= value->data_type->dimy)
                return NULL;
            swiz |= (y << 4 | x) << component * 8;
            component++;
        }
        return new_swizzle(swiz, component, value, loc);
    }

    /* Vector swizzle */
    if (len > 4)
        return NULL;

    for (set = 0; set < 2; ++set)
    {
        valid = TRUE;
        component = 0;
        for (i = 0; i < len; ++i)
        {
            char c[2][4] = {{'x', 'y', 'z', 'w'}, {'r', 'g', 'b', 'a'}};
            unsigned int s = 0;

            for (s = 0; s < 4; ++s)
            {
                if (swizzle[i] == c[set][s])
                    break;
            }
            if (s == 4)
            {
                valid = FALSE;
                break;
            }

            if (s >= value->data_type->dimx)
                return NULL;
            swiz |= s << component * 2;
            component++;
        }
        if (valid)
            return new_swizzle(swiz, component, value, loc);
    }

    return NULL;
}

static void struct_var_initializer(struct list *list, struct hlsl_ir_var *var, struct list *initializer)
{
    struct hlsl_type *type = var->node.data_type;
    struct hlsl_ir_node *node;
    struct hlsl_struct_field *field;
    struct list *cur_node;
    struct hlsl_ir_node *assignment;
    struct hlsl_ir_deref *deref;

    if (initializer_size(initializer) != components_count_type(type))
    {
        hlsl_report_message(var->node.loc.file, var->node.loc.line, var->node.loc.col, HLSL_LEVEL_ERROR,
                "structure initializer mismatch");
        free_instr_list(initializer);
        return;
    }
    cur_node = list_head(initializer);
    assert(cur_node);
    node = LIST_ENTRY(cur_node, struct hlsl_ir_node, entry);
    LIST_FOR_EACH_ENTRY(field, type->e.elements, struct hlsl_struct_field, entry)
    {
        if (!cur_node)
        {
            d3dcompiler_free(initializer);
            return;
        }
        if (components_count_type(field->type) == components_count_type(node->data_type))
        {
            deref = new_record_deref(&var->node, field);
            if (!deref)
            {
                ERR("Out of memory.\n");
                break;
            }
            deref->node.loc = node->loc;
            assignment = make_assignment(&deref->node, ASSIGN_OP_ASSIGN, BWRITERSP_WRITEMASK_ALL, node);
            list_add_tail(list, &assignment->entry);
        }
        else
            FIXME("Initializing with \"mismatched\" fields is not supported yet.\n");
        cur_node = list_next(initializer, cur_node);
        node = LIST_ENTRY(cur_node, struct hlsl_ir_node, entry);
    }

    /* Free initializer elements in excess. */
    while (cur_node)
    {
        struct list *next = list_next(initializer, cur_node);
        free_instr(node);
        cur_node = next;
        node = LIST_ENTRY(cur_node, struct hlsl_ir_node, entry);
    }
    d3dcompiler_free(initializer);
}

static struct list *declare_vars(struct hlsl_type *basic_type, DWORD modifiers, struct list *var_list)
{
    struct hlsl_type *type;
    struct parse_variable_def *v, *v_next;
    struct hlsl_ir_var *var;
    struct hlsl_ir_node *assignment;
    BOOL ret, local = TRUE;
    struct list *statements_list = d3dcompiler_alloc(sizeof(*statements_list));

    if (!statements_list)
    {
        ERR("Out of memory.\n");
        LIST_FOR_EACH_ENTRY_SAFE(v, v_next, var_list, struct parse_variable_def, entry)
            d3dcompiler_free(v);
        d3dcompiler_free(var_list);
        return NULL;
    }
    list_init(statements_list);

    if (!var_list)
        return statements_list;

    LIST_FOR_EACH_ENTRY_SAFE(v, v_next, var_list, struct parse_variable_def, entry)
    {
        var = d3dcompiler_alloc(sizeof(*var));
        if (!var)
        {
            ERR("Out of memory.\n");
            d3dcompiler_free(v);
            continue;
        }
        var->node.type = HLSL_IR_VAR;
        if (v->array_size)
            type = new_array_type(basic_type, v->array_size);
        else
            type = basic_type;
        var->node.data_type = type;
        var->node.loc = v->loc;
        var->name = v->name;
        var->modifiers = modifiers;
        var->semantic = v->semantic;
        debug_dump_decl(type, modifiers, v->name, v->loc.line);

        if (hlsl_ctx.cur_scope == hlsl_ctx.globals)
        {
            var->modifiers |= HLSL_STORAGE_UNIFORM;
            local = FALSE;
        }

        if (var->modifiers & HLSL_MODIFIER_CONST && !(var->modifiers & HLSL_STORAGE_UNIFORM) && !v->initializer)
        {
            hlsl_report_message(v->loc.file, v->loc.line, v->loc.col,
                    HLSL_LEVEL_ERROR, "const variable without initializer");
            free_declaration(var);
            d3dcompiler_free(v);
            continue;
        }

        ret = declare_variable(var, local);
        if (!ret)
        {
            free_declaration(var);
            d3dcompiler_free(v);
            continue;
        }
        TRACE("Declared variable %s.\n", var->name);

        if (v->initializer)
        {
            unsigned int size = initializer_size(v->initializer);
            struct hlsl_ir_node *node;

            TRACE("Variable with initializer.\n");
            if (type->type <= HLSL_CLASS_LAST_NUMERIC
                    && type->dimx * type->dimy != size && size != 1)
            {
                if (size < type->dimx * type->dimy)
                {
                    hlsl_report_message(v->loc.file, v->loc.line, v->loc.col, HLSL_LEVEL_ERROR,
                            "'%s' initializer does not match", v->name);
                    free_instr_list(v->initializer);
                    d3dcompiler_free(v);
                    continue;
                }
            }
            if ((type->type == HLSL_CLASS_STRUCT || type->type == HLSL_CLASS_ARRAY)
                    && components_count_type(type) != size)
            {
                hlsl_report_message(v->loc.file, v->loc.line, v->loc.col, HLSL_LEVEL_ERROR,
                        "'%s' initializer does not match", v->name);
                free_instr_list(v->initializer);
                d3dcompiler_free(v);
                continue;
            }

            if (type->type == HLSL_CLASS_STRUCT)
            {
                struct_var_initializer(statements_list, var, v->initializer);
                d3dcompiler_free(v);
                continue;
            }
            if (type->type > HLSL_CLASS_LAST_NUMERIC)
            {
                FIXME("Initializers for non scalar/struct variables not supported yet.\n");
                free_instr_list(v->initializer);
                d3dcompiler_free(v);
                continue;
            }
            if (v->array_size > 0)
            {
                FIXME("Initializing arrays is not supported yet.\n");
                free_instr_list(v->initializer);
                d3dcompiler_free(v);
                continue;
            }
            if (list_count(v->initializer) > 1)
            {
                FIXME("Complex initializers are not supported yet.\n");
                free_instr_list(v->initializer);
                d3dcompiler_free(v);
                continue;
            }
            node = LIST_ENTRY(list_head(v->initializer), struct hlsl_ir_node, entry);
            assignment = make_assignment(&var->node, ASSIGN_OP_ASSIGN,
                    BWRITERSP_WRITEMASK_ALL, node);
            list_add_tail(statements_list, &assignment->entry);
            d3dcompiler_free(v->initializer);
        }
        d3dcompiler_free(v);
    }
    d3dcompiler_free(var_list);
    return statements_list;
}

static BOOL add_struct_field(struct list *fields, struct hlsl_struct_field *field)
{
    struct hlsl_struct_field *f;

    LIST_FOR_EACH_ENTRY(f, fields, struct hlsl_struct_field, entry)
    {
        if (!strcmp(f->name, field->name))
            return FALSE;
    }
    list_add_tail(fields, &field->entry);
    return TRUE;
}

static struct list *gen_struct_fields(struct hlsl_type *type, DWORD modifiers, struct list *fields)
{
    struct parse_variable_def *v, *v_next;
    struct hlsl_struct_field *field;
    struct list *list;

    list = d3dcompiler_alloc(sizeof(*list));
    if (!list)
    {
        ERR("Out of memory.\n");
        return NULL;
    }
    list_init(list);
    LIST_FOR_EACH_ENTRY_SAFE(v, v_next, fields, struct parse_variable_def, entry)
    {
        debug_dump_decl(type, 0, v->name, v->loc.line);
        field = d3dcompiler_alloc(sizeof(*field));
        if (!field)
        {
            ERR("Out of memory.\n");
            d3dcompiler_free(v);
            return list;
        }
        field->type = type;
        field->name = v->name;
        field->modifiers = modifiers;
        field->semantic = v->semantic;
        if (v->initializer)
        {
            hlsl_report_message(v->loc.file, v->loc.line, v->loc.col, HLSL_LEVEL_ERROR,
                    "struct field with an initializer.\n");
            free_instr_list(v->initializer);
        }
        list_add_tail(list, &field->entry);
        d3dcompiler_free(v);
    }
    d3dcompiler_free(fields);
    return list;
}

static struct hlsl_type *new_struct_type(const char *name, DWORD modifiers, struct list *fields)
{
    struct hlsl_type *type = d3dcompiler_alloc(sizeof(*type));

    if (!type)
    {
        ERR("Out of memory.\n");
        return NULL;
    }
    type->type = HLSL_CLASS_STRUCT;
    type->name = name;
    type->dimx = type->dimy = 1;
    type->modifiers = modifiers;
    type->e.elements = fields;

    list_add_tail(&hlsl_ctx.types, &type->entry);

    return type;
}

static BOOL add_typedef(DWORD modifiers, struct hlsl_type *orig_type, struct list *list,
        struct source_location *loc)
{
    BOOL ret;
    struct hlsl_type *type;
    struct parse_variable_def *v, *v_next;

    if (!check_type_modifiers(modifiers, loc))
    {
        LIST_FOR_EACH_ENTRY_SAFE(v, v_next, list, struct parse_variable_def, entry)
            d3dcompiler_free(v);
        d3dcompiler_free(list);
        return FALSE;
    }

    LIST_FOR_EACH_ENTRY_SAFE(v, v_next, list, struct parse_variable_def, entry)
    {
        if (v->array_size)
            type = new_array_type(orig_type, v->array_size);
        else
            type = clone_hlsl_type(orig_type);
        if (!type)
        {
            ERR("Out of memory\n");
            return FALSE;
        }
        d3dcompiler_free((void *)type->name);
        type->name = v->name;
        type->modifiers |= modifiers;

        if (type->type != HLSL_CLASS_MATRIX)
            check_invalid_matrix_modifiers(type->modifiers, &v->loc);

        ret = add_type_to_scope(hlsl_ctx.cur_scope, type);
        if (!ret)
        {
            hlsl_report_message(v->loc.file, v->loc.line, v->loc.col, HLSL_LEVEL_ERROR,
                    "redefinition of custom type '%s'", v->name);
        }
        d3dcompiler_free(v);
    }
    d3dcompiler_free(list);
    return TRUE;
}

static const struct hlsl_ir_function_decl *get_overloaded_func(struct wine_rb_tree *funcs, char *name,
        struct list *params, BOOL exact_signature)
{
    struct hlsl_ir_function *func;
    struct wine_rb_entry *entry;

    entry = wine_rb_get(funcs, name);
    if (entry)
    {
        func = WINE_RB_ENTRY_VALUE(entry, struct hlsl_ir_function, entry);

        entry = wine_rb_get(&func->overloads, params);
        if (!entry)
        {
            if (!exact_signature)
                FIXME("No exact match, search for a compatible overloaded function (if any).\n");
            return NULL;
        }
        return WINE_RB_ENTRY_VALUE(entry, struct hlsl_ir_function_decl, entry);
    }
    return NULL;
}



/* Line 189 of yacc.c  */
#line 896 "hlsl.tab.c"

/* Enabling traces.  */
#ifndef YYDEBUG
# define YYDEBUG 0
#endif

/* Enabling verbose error messages.  */
#ifdef YYERROR_VERBOSE
# undef YYERROR_VERBOSE
# define YYERROR_VERBOSE 1
#else
# define YYERROR_VERBOSE 1
#endif

/* Enabling the token table.  */
#ifndef YYTOKEN_TABLE
# define YYTOKEN_TABLE 0
#endif


/* Tokens.  */
#ifndef YYTOKENTYPE
# define YYTOKENTYPE
   /* Put the tokens into the symbol table, so that GDB and other debuggers
      know about them.  */
   enum yytokentype {
     KW_BLENDSTATE = 258,
     KW_BREAK = 259,
     KW_BUFFER = 260,
     KW_CBUFFER = 261,
     KW_COLUMN_MAJOR = 262,
     KW_COMPILE = 263,
     KW_CONST = 264,
     KW_CONTINUE = 265,
     KW_DEPTHSTENCILSTATE = 266,
     KW_DEPTHSTENCILVIEW = 267,
     KW_DISCARD = 268,
     KW_DO = 269,
     KW_DOUBLE = 270,
     KW_ELSE = 271,
     KW_EXTERN = 272,
     KW_FALSE = 273,
     KW_FOR = 274,
     KW_GEOMETRYSHADER = 275,
     KW_GROUPSHARED = 276,
     KW_IF = 277,
     KW_IN = 278,
     KW_INLINE = 279,
     KW_INOUT = 280,
     KW_MATRIX = 281,
     KW_NAMESPACE = 282,
     KW_NOINTERPOLATION = 283,
     KW_OUT = 284,
     KW_PASS = 285,
     KW_PIXELSHADER = 286,
     KW_PRECISE = 287,
     KW_RASTERIZERSTATE = 288,
     KW_RENDERTARGETVIEW = 289,
     KW_RETURN = 290,
     KW_REGISTER = 291,
     KW_ROW_MAJOR = 292,
     KW_SAMPLER = 293,
     KW_SAMPLER1D = 294,
     KW_SAMPLER2D = 295,
     KW_SAMPLER3D = 296,
     KW_SAMPLERCUBE = 297,
     KW_SAMPLER_STATE = 298,
     KW_SAMPLERCOMPARISONSTATE = 299,
     KW_SHARED = 300,
     KW_STATEBLOCK = 301,
     KW_STATEBLOCK_STATE = 302,
     KW_STATIC = 303,
     KW_STRING = 304,
     KW_STRUCT = 305,
     KW_SWITCH = 306,
     KW_TBUFFER = 307,
     KW_TECHNIQUE = 308,
     KW_TECHNIQUE10 = 309,
     KW_TEXTURE = 310,
     KW_TEXTURE1D = 311,
     KW_TEXTURE1DARRAY = 312,
     KW_TEXTURE2D = 313,
     KW_TEXTURE2DARRAY = 314,
     KW_TEXTURE2DMS = 315,
     KW_TEXTURE2DMSARRAY = 316,
     KW_TEXTURE3D = 317,
     KW_TEXTURE3DARRAY = 318,
     KW_TEXTURECUBE = 319,
     KW_TRUE = 320,
     KW_TYPEDEF = 321,
     KW_UNIFORM = 322,
     KW_VECTOR = 323,
     KW_VERTEXSHADER = 324,
     KW_VOID = 325,
     KW_VOLATILE = 326,
     KW_WHILE = 327,
     OP_INC = 328,
     OP_DEC = 329,
     OP_AND = 330,
     OP_OR = 331,
     OP_EQ = 332,
     OP_LEFTSHIFT = 333,
     OP_LEFTSHIFTASSIGN = 334,
     OP_RIGHTSHIFT = 335,
     OP_RIGHTSHIFTASSIGN = 336,
     OP_ELLIPSIS = 337,
     OP_LE = 338,
     OP_GE = 339,
     OP_NE = 340,
     OP_ADDASSIGN = 341,
     OP_SUBASSIGN = 342,
     OP_MULASSIGN = 343,
     OP_DIVASSIGN = 344,
     OP_MODASSIGN = 345,
     OP_ANDASSIGN = 346,
     OP_ORASSIGN = 347,
     OP_XORASSIGN = 348,
     OP_UNKNOWN1 = 349,
     OP_UNKNOWN2 = 350,
     OP_UNKNOWN3 = 351,
     OP_UNKNOWN4 = 352,
     PRE_LINE = 353,
     VAR_IDENTIFIER = 354,
     TYPE_IDENTIFIER = 355,
     NEW_IDENTIFIER = 356,
     STRING = 357,
     C_FLOAT = 358,
     C_INTEGER = 359
   };
#endif



#if ! defined YYSTYPE && ! defined YYSTYPE_IS_DECLARED
typedef union YYSTYPE
{

/* Line 214 of yacc.c  */
#line 841 "hlsl.y"

    struct hlsl_type *type;
    INT intval;
    FLOAT floatval;
    BOOL boolval;
    char *name;
    DWORD modifiers;
    struct hlsl_ir_var *var;
    struct hlsl_ir_node *instr;
    struct list *list;
    struct parse_function function;
    struct parse_parameter parameter;
    struct parse_variable_def *variable_def;
    struct parse_if_body if_body;
    enum parse_unary_op unary_op;
    enum parse_assign_op assign_op;



/* Line 214 of yacc.c  */
#line 1056 "hlsl.tab.c"
} YYSTYPE;
# define YYSTYPE_IS_TRIVIAL 1
# define yystype YYSTYPE /* obsolescent; will be withdrawn */
# define YYSTYPE_IS_DECLARED 1
#endif

#if ! defined YYLTYPE && ! defined YYLTYPE_IS_DECLARED
typedef struct YYLTYPE
{
  int first_line;
  int first_column;
  int last_line;
  int last_column;
} YYLTYPE;
# define yyltype YYLTYPE /* obsolescent; will be withdrawn */
# define YYLTYPE_IS_DECLARED 1
# define YYLTYPE_IS_TRIVIAL 1
#endif


/* Copy the second part of user declarations.  */


/* Line 264 of yacc.c  */
#line 1081 "hlsl.tab.c"

#ifdef short
# undef short
#endif

#ifdef YYTYPE_UINT8
typedef YYTYPE_UINT8 yytype_uint8;
#else
typedef unsigned char yytype_uint8;
#endif

#ifdef YYTYPE_INT8
typedef YYTYPE_INT8 yytype_int8;
#elif (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
typedef signed char yytype_int8;
#else
typedef short int yytype_int8;
#endif

#ifdef YYTYPE_UINT16
typedef YYTYPE_UINT16 yytype_uint16;
#else
typedef unsigned short int yytype_uint16;
#endif

#ifdef YYTYPE_INT16
typedef YYTYPE_INT16 yytype_int16;
#else
typedef short int yytype_int16;
#endif

#ifndef YYSIZE_T
# ifdef __SIZE_TYPE__
#  define YYSIZE_T __SIZE_TYPE__
# elif defined size_t
#  define YYSIZE_T size_t
# elif ! defined YYSIZE_T && (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
#  include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  define YYSIZE_T size_t
# else
#  define YYSIZE_T unsigned int
# endif
#endif

#define YYSIZE_MAXIMUM ((YYSIZE_T) -1)

#ifndef YY_
# if defined YYENABLE_NLS && YYENABLE_NLS
#  if ENABLE_NLS
#   include <libintl.h> /* INFRINGES ON USER NAME SPACE */
#   define YY_(msgid) dgettext ("bison-runtime", msgid)
#  endif
# endif
# ifndef YY_
#  define YY_(msgid) msgid
# endif
#endif

/* Suppress unused-variable warnings by "using" E.  */
#if ! defined lint || defined __GNUC__
# define YYUSE(e) ((void) (e))
#else
# define YYUSE(e) /* empty */
#endif

/* Identity function, used to suppress warnings about constant conditions.  */
#ifndef lint
# define YYID(n) (n)
#else
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static int
YYID (int yyi)
#else
static int
YYID (yyi)
    int yyi;
#endif
{
  return yyi;
}
#endif

#if ! defined yyoverflow || YYERROR_VERBOSE

/* The parser invokes alloca or malloc; define the necessary symbols.  */

# ifdef YYSTACK_USE_ALLOCA
#  if YYSTACK_USE_ALLOCA
#   ifdef __GNUC__
#    define YYSTACK_ALLOC __builtin_alloca
#   elif defined __BUILTIN_VA_ARG_INCR
#    include <alloca.h> /* INFRINGES ON USER NAME SPACE */
#   elif defined _AIX
#    define YYSTACK_ALLOC __alloca
#   elif defined _MSC_VER
#    include <malloc.h> /* INFRINGES ON USER NAME SPACE */
#    define alloca _alloca
#   else
#    define YYSTACK_ALLOC alloca
#    if ! defined _ALLOCA_H && ! defined _STDLIB_H && (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
#     include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#     ifndef _STDLIB_H
#      define _STDLIB_H 1
#     endif
#    endif
#   endif
#  endif
# endif

# ifdef YYSTACK_ALLOC
   /* Pacify GCC's `empty if-body' warning.  */
#  define YYSTACK_FREE(Ptr) do { /* empty */; } while (YYID (0))
#  ifndef YYSTACK_ALLOC_MAXIMUM
    /* The OS might guarantee only one guard page at the bottom of the stack,
       and a page size can be as small as 4096 bytes.  So we cannot safely
       invoke alloca (N) if N exceeds 4096.  Use a slightly smaller number
       to allow for a few compiler-allocated temporary stack slots.  */
#   define YYSTACK_ALLOC_MAXIMUM 4032 /* reasonable circa 2006 */
#  endif
# else
#  define YYSTACK_ALLOC YYMALLOC
#  define YYSTACK_FREE YYFREE
#  ifndef YYSTACK_ALLOC_MAXIMUM
#   define YYSTACK_ALLOC_MAXIMUM YYSIZE_MAXIMUM
#  endif
#  if (defined __cplusplus && ! defined _STDLIB_H \
       && ! ((defined YYMALLOC || defined malloc) \
	     && (defined YYFREE || defined free)))
#   include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#   ifndef _STDLIB_H
#    define _STDLIB_H 1
#   endif
#  endif
#  ifndef YYMALLOC
#   define YYMALLOC malloc
#   if ! defined malloc && ! defined _STDLIB_H && (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
void *malloc (YYSIZE_T); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
#  ifndef YYFREE
#   define YYFREE free
#   if ! defined free && ! defined _STDLIB_H && (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
void free (void *); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
# endif
#endif /* ! defined yyoverflow || YYERROR_VERBOSE */


#if (! defined yyoverflow \
     && (! defined __cplusplus \
	 || (defined YYLTYPE_IS_TRIVIAL && YYLTYPE_IS_TRIVIAL \
	     && defined YYSTYPE_IS_TRIVIAL && YYSTYPE_IS_TRIVIAL)))

/* A type that is properly aligned for any stack member.  */
union yyalloc
{
  yytype_int16 yyss_alloc;
  YYSTYPE yyvs_alloc;
  YYLTYPE yyls_alloc;
};

/* The size of the maximum gap between one aligned stack and the next.  */
# define YYSTACK_GAP_MAXIMUM (sizeof (union yyalloc) - 1)

/* The size of an array large to enough to hold all stacks, each with
   N elements.  */
# define YYSTACK_BYTES(N) \
     ((N) * (sizeof (yytype_int16) + sizeof (YYSTYPE) + sizeof (YYLTYPE)) \
      + 2 * YYSTACK_GAP_MAXIMUM)

/* Copy COUNT objects from FROM to TO.  The source and destination do
   not overlap.  */
# ifndef YYCOPY
#  if defined __GNUC__ && 1 < __GNUC__
#   define YYCOPY(To, From, Count) \
      __builtin_memcpy (To, From, (Count) * sizeof (*(From)))
#  else
#   define YYCOPY(To, From, Count)		\
      do					\
	{					\
	  YYSIZE_T yyi;				\
	  for (yyi = 0; yyi < (Count); yyi++)	\
	    (To)[yyi] = (From)[yyi];		\
	}					\
      while (YYID (0))
#  endif
# endif

/* Relocate STACK from its old location to the new one.  The
   local variables YYSIZE and YYSTACKSIZE give the old and new number of
   elements in the stack, and YYPTR gives the new location of the
   stack.  Advance YYPTR to a properly aligned location for the next
   stack.  */
# define YYSTACK_RELOCATE(Stack_alloc, Stack)				\
    do									\
      {									\
	YYSIZE_T yynewbytes;						\
	YYCOPY (&yyptr->Stack_alloc, Stack, yysize);			\
	Stack = &yyptr->Stack_alloc;					\
	yynewbytes = yystacksize * sizeof (*Stack) + YYSTACK_GAP_MAXIMUM; \
	yyptr += yynewbytes / sizeof (*yyptr);				\
      }									\
    while (YYID (0))

#endif

/* YYFINAL -- State number of the termination state.  */
#define YYFINAL  2
/* YYLAST -- Last index in YYTABLE.  */
#define YYLAST   756

/* YYNTOKENS -- Number of terminals.  */
#define YYNTOKENS  129
/* YYNNTS -- Number of nonterminals.  */
#define YYNNTS  63
/* YYNRULES -- Number of rules.  */
#define YYNRULES  169
/* YYNRULES -- Number of states.  */
#define YYNSTATES  309

/* YYTRANSLATE(YYLEX) -- Bison symbol number corresponding to YYLEX.  */
#define YYUNDEFTOK  2
#define YYMAXUTOK   359

#define YYTRANSLATE(YYX)						\
  ((unsigned int) (YYX) <= YYMAXUTOK ? yytranslate[YYX] : YYUNDEFTOK)

/* YYTRANSLATE[YYLEX] -- Bison symbol number corresponding to YYLEX.  */
static const yytype_uint8 yytranslate[] =
{
       0,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,   120,     2,     2,     2,   124,   125,     2,
     108,   109,   122,   118,   111,   119,   117,   123,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,   110,   105,
     112,   114,   113,   128,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,   115,     2,   116,   126,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,   106,   127,   107,   121,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     1,     2,     3,     4,
       5,     6,     7,     8,     9,    10,    11,    12,    13,    14,
      15,    16,    17,    18,    19,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    29,    30,    31,    32,    33,    34,
      35,    36,    37,    38,    39,    40,    41,    42,    43,    44,
      45,    46,    47,    48,    49,    50,    51,    52,    53,    54,
      55,    56,    57,    58,    59,    60,    61,    62,    63,    64,
      65,    66,    67,    68,    69,    70,    71,    72,    73,    74,
      75,    76,    77,    78,    79,    80,    81,    82,    83,    84,
      85,    86,    87,    88,    89,    90,    91,    92,    93,    94,
      95,    96,    97,    98,    99,   100,   101,   102,   103,   104
};

#if YYDEBUG
/* YYPRHS[YYN] -- Index of the first RHS symbol of rule number YYN in
   YYRHS.  */
static const yytype_uint16 yyprhs[] =
{
       0,     0,     3,     4,     7,    10,    13,    16,    20,    22,
      24,    31,    37,    39,    41,    43,    44,    47,    52,    56,
      59,    62,    70,    73,    78,    79,    81,    83,    84,    87,
      89,    92,    94,    98,   104,   105,   108,   110,   112,   114,
     116,   123,   132,   134,   136,   138,   140,   142,   144,   146,
     149,   151,   153,   155,   161,   166,   168,   172,   175,   180,
     181,   183,   185,   189,   193,   199,   200,   204,   205,   208,
     211,   214,   217,   220,   223,   226,   229,   232,   235,   238,
     240,   244,   246,   248,   252,   254,   256,   258,   261,   263,
     265,   267,   269,   271,   273,   277,   283,   285,   289,   295,
     303,   312,   321,   323,   326,   328,   330,   332,   334,   338,
     340,   342,   345,   348,   352,   357,   363,   365,   368,   371,
     374,   381,   383,   385,   387,   389,   391,   395,   399,   403,
     405,   409,   413,   415,   419,   423,   425,   429,   433,   437,
     441,   443,   447,   451,   453,   457,   459,   463,   465,   469,
     471,   475,   477,   481,   483,   489,   491,   495,   497,   499,
     501,   503,   505,   507,   509,   511,   513,   515,   517,   519
};

/* YYRHS -- A `-1'-separated list of the rules' RHS.  */
static const yytype_int16 yyrhs[] =
{
     130,     0,    -1,    -1,   130,   139,    -1,   130,   152,    -1,
     130,   131,    -1,    98,   102,    -1,   133,   157,   105,    -1,
     134,    -1,   135,    -1,   161,    50,   136,   106,   137,   107,
      -1,   161,    50,   106,   137,   107,    -1,    99,    -1,   100,
      -1,   101,    -1,    -1,   137,   138,    -1,   161,   150,   158,
     105,    -1,   135,   158,   105,    -1,   140,   141,    -1,   140,
     105,    -1,   161,   150,   143,   108,   145,   109,   144,    -1,
     106,   107,    -1,   106,   142,   166,   107,    -1,    -1,    99,
      -1,   101,    -1,    -1,   110,   136,    -1,   142,    -1,   142,
     146,    -1,   147,    -1,   146,   111,   147,    -1,   148,   161,
     150,   136,   144,    -1,    -1,   148,   149,    -1,    23,    -1,
      29,    -1,    25,    -1,   151,    -1,    68,   112,   151,   111,
     104,   113,    -1,    26,   112,   151,   111,   104,   111,   104,
     113,    -1,    70,    -1,    38,    -1,    39,    -1,    40,    -1,
      41,    -1,    42,    -1,   100,    -1,    50,   100,    -1,   156,
      -1,   132,    -1,   153,    -1,    66,   161,   150,   154,   105,
      -1,    66,   133,   154,   105,    -1,   155,    -1,   154,   111,
     155,    -1,   136,   160,    -1,   161,   150,   158,   105,    -1,
      -1,   158,    -1,   159,    -1,   158,   111,   159,    -1,   136,
     160,   144,    -1,   136,   160,   144,   114,   162,    -1,    -1,
     115,   191,   116,    -1,    -1,    17,   161,    -1,    28,   161,
      -1,    32,   161,    -1,    45,   161,    -1,    21,   161,    -1,
      48,   161,    -1,    67,   161,    -1,    71,   161,    -1,     9,
     161,    -1,    37,   161,    -1,     7,   161,    -1,   163,    -1,
     106,   164,   107,    -1,   189,    -1,   163,    -1,   164,   111,
     163,    -1,    65,    -1,    18,    -1,   167,    -1,   166,   167,
      -1,   152,    -1,   172,    -1,   141,    -1,   168,    -1,   169,
      -1,   171,    -1,    35,   191,   105,    -1,    22,   108,   191,
     109,   170,    -1,   167,    -1,   167,    16,   167,    -1,    72,
     108,   191,   109,   167,    -1,    14,   167,    72,   108,   191,
     109,   105,    -1,    19,   108,   142,   172,   172,   191,   109,
     167,    -1,    19,   108,   142,   156,   172,   191,   109,   167,
      -1,   105,    -1,   191,   105,    -1,   103,    -1,   104,    -1,
     165,    -1,   174,    -1,   108,   191,   109,    -1,    99,    -1,
     173,    -1,   175,    73,    -1,   175,    74,    -1,   175,   117,
     136,    -1,   175,   115,   191,   116,    -1,   161,   150,   108,
     164,   109,    -1,   175,    -1,    73,   176,    -1,    74,   176,
      -1,   177,   176,    -1,   108,   161,   150,   160,   109,   176,
      -1,   118,    -1,   119,    -1,   120,    -1,   121,    -1,   176,
      -1,   178,   122,   176,    -1,   178,   123,   176,    -1,   178,
     124,   176,    -1,   178,    -1,   179,   118,   178,    -1,   179,
     119,   178,    -1,   179,    -1,   180,    78,   179,    -1,   180,
      80,   179,    -1,   180,    -1,   181,   112,   180,    -1,   181,
     113,   180,    -1,   181,    83,   180,    -1,   181,    84,   180,
      -1,   181,    -1,   182,    77,   181,    -1,   182,    85,   181,
      -1,   182,    -1,   183,   125,   182,    -1,   183,    -1,   184,
     126,   183,    -1,   184,    -1,   185,   127,   184,    -1,   185,
      -1,   186,    75,   185,    -1,   186,    -1,   187,    76,   186,
      -1,   187,    -1,   187,   128,   191,   110,   189,    -1,   188,
      -1,   176,   190,   189,    -1,   114,    -1,    86,    -1,    87,
      -1,    88,    -1,    89,    -1,    90,    -1,    79,    -1,    81,
      -1,    91,    -1,    92,    -1,    93,    -1,   189,    -1,   191,
     111,   189,    -1
};

/* YYRLINE[YYN] -- source line where rule number YYN was defined.  */
static const yytype_uint16 yyrline[] =
{
       0,  1022,  1022,  1024,  1061,  1065,  1069,  1088,  1105,  1106,
    1108,  1134,  1144,  1145,  1146,  1149,  1153,  1172,  1176,  1181,
    1188,  1195,  1220,  1225,  1232,  1236,  1237,  1240,  1243,  1248,
    1253,  1258,  1272,  1286,  1296,  1299,  1310,  1314,  1318,  1323,
    1327,  1346,  1366,  1370,  1375,  1380,  1385,  1390,  1395,  1404,
    1423,  1424,  1425,  1436,  1444,  1453,  1459,  1465,  1473,  1479,
    1482,  1487,  1493,  1499,  1507,  1519,  1522,  1530,  1533,  1537,
    1541,  1545,  1549,  1553,  1557,  1561,  1565,  1569,  1573,  1578,
    1584,  1589,  1594,  1600,  1606,  1610,  1615,  1619,  1626,  1627,
    1628,  1629,  1630,  1631,  1634,  1657,  1681,  1686,  1692,  1707,
    1722,  1730,  1742,  1747,  1755,  1769,  1783,  1797,  1808,  1813,
    1827,  1831,  1850,  1869,  1923,  1983,  2019,  2023,  2039,  2055,
    2075,  2107,  2111,  2115,  2119,  2124,  2128,  2135,  2142,  2150,
    2154,  2161,  2169,  2173,  2177,  2182,  2186,  2193,  2200,  2207,
    2215,  2219,  2226,  2234,  2238,  2243,  2247,  2252,  2256,  2261,
    2265,  2270,  2274,  2279,  2283,  2288,  2292,  2309,  2313,  2317,
    2321,  2325,  2329,  2333,  2337,  2341,  2345,  2349,  2354,  2358
};
#endif

#if YYDEBUG || YYERROR_VERBOSE || YYTOKEN_TABLE
/* YYTNAME[SYMBOL-NUM] -- String name of the symbol SYMBOL-NUM.
   First, the terminals, then, starting at YYNTOKENS, nonterminals.  */
static const char *const yytname[] =
{
  "$end", "error", "$undefined", "KW_BLENDSTATE", "KW_BREAK", "KW_BUFFER",
  "KW_CBUFFER", "KW_COLUMN_MAJOR", "KW_COMPILE", "KW_CONST", "KW_CONTINUE",
  "KW_DEPTHSTENCILSTATE", "KW_DEPTHSTENCILVIEW", "KW_DISCARD", "KW_DO",
  "KW_DOUBLE", "KW_ELSE", "KW_EXTERN", "KW_FALSE", "KW_FOR",
  "KW_GEOMETRYSHADER", "KW_GROUPSHARED", "KW_IF", "KW_IN", "KW_INLINE",
  "KW_INOUT", "KW_MATRIX", "KW_NAMESPACE", "KW_NOINTERPOLATION", "KW_OUT",
  "KW_PASS", "KW_PIXELSHADER", "KW_PRECISE", "KW_RASTERIZERSTATE",
  "KW_RENDERTARGETVIEW", "KW_RETURN", "KW_REGISTER", "KW_ROW_MAJOR",
  "KW_SAMPLER", "KW_SAMPLER1D", "KW_SAMPLER2D", "KW_SAMPLER3D",
  "KW_SAMPLERCUBE", "KW_SAMPLER_STATE", "KW_SAMPLERCOMPARISONSTATE",
  "KW_SHARED", "KW_STATEBLOCK", "KW_STATEBLOCK_STATE", "KW_STATIC",
  "KW_STRING", "KW_STRUCT", "KW_SWITCH", "KW_TBUFFER", "KW_TECHNIQUE",
  "KW_TECHNIQUE10", "KW_TEXTURE", "KW_TEXTURE1D", "KW_TEXTURE1DARRAY",
  "KW_TEXTURE2D", "KW_TEXTURE2DARRAY", "KW_TEXTURE2DMS",
  "KW_TEXTURE2DMSARRAY", "KW_TEXTURE3D", "KW_TEXTURE3DARRAY",
  "KW_TEXTURECUBE", "KW_TRUE", "KW_TYPEDEF", "KW_UNIFORM", "KW_VECTOR",
  "KW_VERTEXSHADER", "KW_VOID", "KW_VOLATILE", "KW_WHILE", "OP_INC",
  "OP_DEC", "OP_AND", "OP_OR", "OP_EQ", "OP_LEFTSHIFT",
  "OP_LEFTSHIFTASSIGN", "OP_RIGHTSHIFT", "OP_RIGHTSHIFTASSIGN",
  "OP_ELLIPSIS", "OP_LE", "OP_GE", "OP_NE", "OP_ADDASSIGN", "OP_SUBASSIGN",
  "OP_MULASSIGN", "OP_DIVASSIGN", "OP_MODASSIGN", "OP_ANDASSIGN",
  "OP_ORASSIGN", "OP_XORASSIGN", "OP_UNKNOWN1", "OP_UNKNOWN2",
  "OP_UNKNOWN3", "OP_UNKNOWN4", "PRE_LINE", "VAR_IDENTIFIER",
  "TYPE_IDENTIFIER", "NEW_IDENTIFIER", "STRING", "C_FLOAT", "C_INTEGER",
  "';'", "'{'", "'}'", "'('", "')'", "':'", "','", "'<'", "'>'", "'='",
  "'['", "']'", "'.'", "'+'", "'-'", "'!'", "'~'", "'*'", "'/'", "'%'",
  "'&'", "'^'", "'|'", "'?'", "$accept", "hlsl_prog", "preproc_directive",
  "struct_declaration", "struct_spec", "named_struct_spec",
  "unnamed_struct_spec", "any_identifier", "fields_list", "field",
  "func_declaration", "func_prototype", "compound_statement",
  "scope_start", "var_identifier", "semantic", "parameters", "param_list",
  "parameter", "input_mods", "input_mod", "type", "base_type",
  "declaration_statement", "typedef", "type_specs", "type_spec",
  "declaration", "variables_def_optional", "variables_def", "variable_def",
  "array", "var_modifiers", "complex_initializer", "initializer_expr",
  "initializer_expr_list", "boolean", "statement_list", "statement",
  "jump_statement", "selection_statement", "if_body", "loop_statement",
  "expr_statement", "primary_expr", "variable", "postfix_expr",
  "unary_expr", "unary_op", "mul_expr", "add_expr", "shift_expr",
  "relational_expr", "equality_expr", "bitand_expr", "bitxor_expr",
  "bitor_expr", "logicand_expr", "logicor_expr", "conditional_expr",
  "assignment_expr", "assign_op", "expr", 0
};
#endif

# ifdef YYPRINT
/* YYTOKNUM[YYLEX-NUM] -- Internal token number corresponding to
   token YYLEX-NUM.  */
static const yytype_uint16 yytoknum[] =
{
       0,   256,   257,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,   269,   270,   271,   272,   273,   274,
     275,   276,   277,   278,   279,   280,   281,   282,   283,   284,
     285,   286,   287,   288,   289,   290,   291,   292,   293,   294,
     295,   296,   297,   298,   299,   300,   301,   302,   303,   304,
     305,   306,   307,   308,   309,   310,   311,   312,   313,   314,
     315,   316,   317,   318,   319,   320,   321,   322,   323,   324,
     325,   326,   327,   328,   329,   330,   331,   332,   333,   334,
     335,   336,   337,   338,   339,   340,   341,   342,   343,   344,
     345,   346,   347,   348,   349,   350,   351,   352,   353,   354,
     355,   356,   357,   358,   359,    59,   123,   125,    40,    41,
      58,    44,    60,    62,    61,    91,    93,    46,    43,    45,
      33,   126,    42,    47,    37,    38,    94,   124,    63
};
# endif

/* YYR1[YYN] -- Symbol number of symbol that rule YYN derives.  */
static const yytype_uint8 yyr1[] =
{
       0,   129,   130,   130,   130,   130,   131,   132,   133,   133,
     134,   135,   136,   136,   136,   137,   137,   138,   138,   139,
     139,   140,   141,   141,   142,   143,   143,   144,   144,   145,
     145,   146,   146,   147,   148,   148,   149,   149,   149,   150,
     150,   150,   151,   151,   151,   151,   151,   151,   151,   151,
     152,   152,   152,   153,   153,   154,   154,   155,   156,   157,
     157,   158,   158,   159,   159,   160,   160,   161,   161,   161,
     161,   161,   161,   161,   161,   161,   161,   161,   161,   162,
     162,   163,   164,   164,   165,   165,   166,   166,   167,   167,
     167,   167,   167,   167,   168,   169,   170,   170,   171,   171,
     171,   171,   172,   172,   173,   173,   173,   173,   173,   174,
     175,   175,   175,   175,   175,   175,   176,   176,   176,   176,
     176,   177,   177,   177,   177,   178,   178,   178,   178,   179,
     179,   179,   180,   180,   180,   181,   181,   181,   181,   181,
     182,   182,   182,   183,   183,   184,   184,   185,   185,   186,
     186,   187,   187,   188,   188,   189,   189,   190,   190,   190,
     190,   190,   190,   190,   190,   190,   190,   190,   191,   191
};

/* YYR2[YYN] -- Number of symbols composing right hand side of rule YYN.  */
static const yytype_uint8 yyr2[] =
{
       0,     2,     0,     2,     2,     2,     2,     3,     1,     1,
       6,     5,     1,     1,     1,     0,     2,     4,     3,     2,
       2,     7,     2,     4,     0,     1,     1,     0,     2,     1,
       2,     1,     3,     5,     0,     2,     1,     1,     1,     1,
       6,     8,     1,     1,     1,     1,     1,     1,     1,     2,
       1,     1,     1,     5,     4,     1,     3,     2,     4,     0,
       1,     1,     3,     3,     5,     0,     3,     0,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     1,
       3,     1,     1,     3,     1,     1,     1,     2,     1,     1,
       1,     1,     1,     1,     3,     5,     1,     3,     5,     7,
       8,     8,     1,     2,     1,     1,     1,     1,     3,     1,
       1,     2,     2,     3,     4,     5,     1,     2,     2,     2,
       6,     1,     1,     1,     1,     1,     3,     3,     3,     1,
       3,     3,     1,     3,     3,     1,     3,     3,     3,     3,
       1,     3,     3,     1,     3,     1,     3,     1,     3,     1,
       3,     1,     3,     1,     5,     1,     3,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     3
};

/* YYDEFACT[STATE-NAME] -- Default rule to reduce with in state
   STATE-NUM when YYTABLE doesn't specify something else to do.  Zero
   means the default is an error.  */
static const yytype_uint8 yydefact[] =
{
       2,    67,     1,    67,    67,    67,    67,    67,    67,    67,
      67,    67,    67,    67,    67,     0,     5,    51,    59,     8,
       9,     3,     0,     4,    52,    50,     0,    78,    76,    68,
      72,    69,    70,    77,    71,    73,     0,     0,    74,    75,
       6,    12,    13,    14,    65,     0,    60,    61,    20,    24,
      19,     0,    43,    44,    45,    46,    47,     0,     0,    42,
      48,     0,    39,    65,     0,    55,     0,    67,    27,     7,
       0,    22,    67,     0,    49,    15,     0,     0,    12,    14,
       0,     0,    57,    54,     0,     0,    85,    84,    67,    67,
     109,   104,   105,    67,   121,   122,   123,   124,     0,   106,
     110,   107,   116,   125,    67,   129,   132,   135,   140,   143,
     145,   147,   149,   151,   153,   155,   168,     0,     0,    63,
      62,    67,     0,     0,    67,     0,   102,    90,    88,     0,
      67,    86,    91,    92,    93,    89,     0,     0,     0,    67,
      15,     0,    24,    58,    56,    53,   117,   118,     0,     0,
       0,   111,   112,    67,     0,   163,   164,   158,   159,   160,
     161,   162,   165,   166,   167,   157,    67,   119,    67,    67,
      67,    67,    67,    67,    67,    67,    67,    67,    67,    67,
      67,    67,    67,    67,    67,    67,    67,    67,    66,    28,
      67,     0,    24,    67,     0,    67,     0,    23,    87,   103,
      49,     0,    11,     0,    16,     0,    67,     0,    34,     0,
      65,   108,    67,     0,   113,   156,   126,   127,   128,   125,
     130,   131,   133,   134,   138,   139,   136,   137,   141,   142,
     144,   146,   148,   150,   152,     0,   169,    67,    64,    79,
      81,     0,    67,     0,    94,     0,     0,     0,     0,     0,
      10,     0,    30,    31,    67,    27,     0,    82,     0,   114,
      67,     0,    67,    67,     0,    67,    67,    67,     0,    18,
       0,    40,    34,    36,    38,    37,    35,     0,    21,    67,
     115,    67,   154,    80,     0,    67,    67,    96,    95,    98,
       0,    17,    32,     0,   120,    83,     0,     0,     0,    67,
      41,    27,    99,    67,    67,    97,    33,   101,   100
};

/* YYDEFGOTO[NTERM-NUM].  */
static const yytype_int16 yydefgoto[] =
{
      -1,     1,    16,    17,    18,    19,    20,    44,   139,   204,
      21,    22,   127,    72,    80,   119,   209,   252,   253,   254,
     276,   196,    62,   128,    24,    64,    65,    25,    45,    81,
      47,    68,    98,   238,   257,   258,    99,   130,   131,   132,
     133,   288,   134,   135,   100,   101,   102,   103,   104,   105,
     106,   107,   108,   109,   110,   111,   112,   113,   114,   115,
     116,   166,   136
};

/* YYPACT[STATE-NUM] -- Index in YYTABLE of the portion describing
   STATE-NUM.  */
#define YYPACT_NINF -235
static const yytype_int16 yypact[] =
{
    -235,   609,  -235,   685,   685,   685,   685,   685,   685,   685,
     685,   685,   685,   685,   685,   -68,  -235,  -235,    31,  -235,
    -235,  -235,    11,  -235,  -235,  -235,   143,  -235,  -235,  -235,
    -235,  -235,  -235,  -235,  -235,  -235,    31,   143,  -235,  -235,
    -235,  -235,  -235,  -235,   -70,   -46,   -41,  -235,  -235,   -55,
    -235,   -22,  -235,  -235,  -235,  -235,  -235,     4,   -13,  -235,
    -235,    71,  -235,   -70,   -72,  -235,    31,   548,    -2,  -235,
      31,  -235,   350,   288,    22,  -235,    34,   288,    72,    80,
      87,   -43,  -235,  -235,    31,   -42,  -235,  -235,   548,   548,
    -235,  -235,  -235,   548,  -235,  -235,  -235,  -235,   182,  -235,
    -235,  -235,   -30,   313,   548,    51,    49,     1,   -59,   -45,
      66,    74,    10,   129,   -53,  -235,  -235,   -69,    31,   101,
    -235,   350,   104,   111,   548,   119,  -235,  -235,  -235,   143,
     242,  -235,  -235,  -235,  -235,  -235,   -27,   130,   120,    29,
    -235,   124,  -235,  -235,  -235,  -235,  -235,  -235,   182,    24,
     131,  -235,  -235,   548,    31,  -235,  -235,  -235,  -235,  -235,
    -235,  -235,  -235,  -235,  -235,  -235,   548,  -235,   548,   548,
     548,   548,   548,   548,   548,   548,   548,   548,   548,   548,
     548,   548,   548,   548,   548,   548,   548,   548,  -235,  -235,
     429,   170,  -235,   548,   -23,   548,    -6,  -235,  -235,  -235,
    -235,   140,  -235,    31,  -235,   254,   169,   142,   138,   139,
     -78,  -235,   548,   -56,  -235,  -235,  -235,  -235,  -235,  -235,
      51,    51,    49,    49,     1,     1,     1,     1,   -59,   -59,
     -45,    66,    74,    10,   129,    12,  -235,   548,  -235,  -235,
    -235,   146,   469,    53,  -235,    68,   151,   -14,     6,    31,
    -235,   144,   156,  -235,   656,    -2,   160,  -235,    78,  -235,
     548,     7,   548,   469,   182,   469,   350,   350,   167,  -235,
       2,  -235,  -235,  -235,  -235,  -235,  -235,   182,  -235,   548,
    -235,   548,  -235,  -235,    83,   548,   548,   256,  -235,  -235,
     162,  -235,  -235,    31,  -235,  -235,   168,    98,   107,   350,
    -235,    -2,  -235,   350,   350,  -235,  -235,  -235,  -235
};

/* YYPGOTO[NTERM-NUM].  */
static const yytype_int16 yypgoto[] =
{
    -235,  -235,  -235,  -235,   266,  -235,  -120,   -35,   141,  -235,
    -235,  -235,   261,  -116,  -235,  -234,  -235,  -235,    13,  -235,
    -235,    -9,    38,   283,  -235,   220,   204,    47,  -235,    -4,
     221,   -47,    -1,  -235,  -172,    60,  -235,  -235,  -101,  -235,
    -235,  -235,  -235,  -207,  -235,  -235,  -235,   -24,  -235,    54,
      55,   -51,    58,   118,   123,   117,   122,   116,  -235,  -235,
    -139,  -235,   -52
};

/* YYTABLE[YYPACT[STATE-NUM]].  What to do in state STATE-NUM.  If
   positive, shift that token.  If negative, reduce the rule which
   number is the opposite.  If zero, do what YYDEFACT says.
   If YYTABLE_NINF, syntax error.  */
#define YYTABLE_NINF -30
static const yytype_int16 yytable[] =
{
      26,    63,    27,    28,    29,    30,    31,    32,    33,    34,
      35,    37,    38,    39,    46,   117,    82,    61,   239,   203,
     191,   278,    76,   185,   175,   176,   208,   215,    66,   198,
     212,    63,   179,    83,    40,   265,     3,    67,     4,    84,
     180,   149,   187,   151,   152,    67,     5,   188,   236,    63,
       6,   240,    71,   177,   178,   187,   285,     7,   286,    69,
     259,     8,   143,   145,   146,   147,     9,   306,    70,    84,
      70,   129,   194,   240,    10,   186,   242,    11,   199,   173,
     167,   174,   244,   189,   187,   153,   203,   154,   187,   150,
      73,   269,   148,    41,    42,    43,    13,    70,   240,    77,
      14,   213,   212,    41,    74,    43,   200,   291,   118,   295,
      75,   138,    75,    70,   283,   141,    48,    49,   281,   214,
     129,   282,   260,   187,   224,   225,   226,   227,   -13,   129,
      41,    42,    43,   211,   235,   187,   202,   183,   205,   210,
     140,   243,   240,   245,   216,   217,   218,   219,   219,   219,
     219,   219,   219,   219,   219,   219,   219,   219,   219,   219,
     219,   219,   266,   256,   187,   287,   289,   171,   172,    51,
      78,    42,    79,   168,   169,   170,     3,   267,     4,   187,
     -25,    52,    53,    54,    55,    56,     5,   280,   -26,   281,
       6,   181,   296,    57,   187,   142,   249,     7,   305,   247,
     182,     8,   307,   308,   184,   205,     9,   303,    51,   187,
     284,    58,   192,    59,    10,   190,   304,    11,   187,   193,
      52,    53,    54,    55,    56,   220,   221,   195,   222,   223,
     200,   201,   137,   297,   298,   207,    13,   228,   229,   212,
      14,   264,   241,    60,   246,   270,   251,   -29,   255,     3,
      58,     4,    59,   277,   262,   294,   121,   271,   301,     5,
      86,   122,   268,     6,   123,   129,   129,   272,   293,   279,
       7,   290,   299,   302,     8,   300,   250,   124,    36,     9,
      51,   206,    60,    50,    23,   292,    85,    10,   144,   263,
      11,   120,    52,    53,    54,    55,    56,   261,   129,   230,
     232,   234,   129,   129,   248,   231,   233,    87,    12,    13,
       0,     0,     0,    14,   125,    88,    89,     0,     0,     0,
       0,     0,    58,     0,    59,     0,    52,    53,    54,    55,
      56,     0,     0,     0,     0,     0,     0,     0,   137,     0,
       0,    90,     0,     0,     0,    91,    92,   126,    49,   197,
      93,     0,     0,     0,    60,     0,     0,     3,    59,     4,
      94,    95,    96,    97,   121,     0,     0,     5,    86,   122,
       0,     6,   123,     0,     0,     0,     0,     0,     7,     0,
       0,     0,     8,     0,     0,   124,     0,     9,    60,     0,
       0,     0,   155,     0,   156,    10,     0,     0,    11,   157,
     158,   159,   160,   161,   162,   163,   164,     0,     0,     0,
       0,     0,     0,     0,     0,    87,    12,    13,     0,     0,
       0,    14,   125,    88,    89,     0,     0,   165,     0,     0,
       0,     0,     0,     0,     0,     0,     3,     0,     4,     0,
       0,     0,     0,     0,     0,     0,     5,    86,     0,    90,
       6,     0,     0,    91,    92,   126,    49,     7,    93,     0,
       0,     8,     0,     0,     0,     0,     9,     0,    94,    95,
      96,    97,     0,     0,    10,     0,     3,    11,     4,     0,
       0,     0,     0,     0,     0,     0,     5,    86,     0,     0,
       6,     0,     0,     0,    87,     0,    13,     7,     0,     0,
      14,     8,    88,    89,     0,     0,     9,     0,     0,     0,
       0,     0,     0,     0,    10,     0,     0,    11,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,    90,     0,
       0,     0,    91,    92,    87,   237,    13,    93,     0,     0,
      14,     0,    88,    89,     0,     0,     0,    94,    95,    96,
      97,     0,     0,     0,     0,     3,     0,     4,     0,     0,
       0,     0,     0,     0,     0,     5,    86,     0,    90,     6,
       0,     0,    91,    92,   126,     0,     7,    93,     0,     0,
       8,     0,     0,     0,     0,     9,     0,    94,    95,    96,
      97,     0,     0,    10,     0,     0,    11,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     2,
       0,     0,     0,    87,     0,    13,     3,     0,     4,    14,
       0,    88,    89,     0,     0,     0,     5,     0,     0,     0,
       6,     0,     0,     0,     0,     0,     0,     7,     0,     0,
       0,     8,     0,     0,     0,     0,     9,    90,     0,     0,
       0,    91,    92,     0,    10,     0,    93,    11,     0,     0,
       0,     0,     0,     3,     0,     4,    94,    95,    96,    97,
       0,     0,     0,     5,     0,    12,    13,     6,     0,   273,
      14,   274,     0,     0,     7,   275,     0,     0,     8,     0,
       0,     0,     3,     9,     4,     0,     0,     0,     0,     0,
       0,    10,     5,     0,    11,     0,     6,    15,     0,     0,
       0,     0,     0,     7,     0,     0,     0,     8,     0,     0,
       0,     0,     9,    13,     0,     0,     0,    14,     0,     0,
      10,     0,     0,    11,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,    13,     0,     0,     0,    14
};

static const yytype_int16 yycheck[] =
{
       1,    36,     3,     4,     5,     6,     7,     8,     9,    10,
      11,    12,    13,    14,    18,    67,    63,    26,   190,   139,
     121,   255,    57,    76,    83,    84,   142,   166,    37,   130,
     108,    66,    77,   105,   102,   242,     7,   115,     9,   111,
      85,    93,   111,    73,    74,   115,    17,   116,   187,    84,
      21,   190,   107,   112,   113,   111,   263,    28,   265,   105,
     116,    32,   105,   105,    88,    89,    37,   301,   111,   111,
     111,    72,   124,   212,    45,   128,   192,    48,   105,    78,
     104,    80,   105,   118,   111,   115,   206,   117,   111,    98,
     112,   105,    93,    99,   100,   101,    67,   111,   237,   112,
      71,   153,   108,    99,   100,   101,   100,   105,   110,   281,
     106,    73,   106,   111,   107,    77,   105,   106,   111,   154,
     121,   260,   110,   111,   175,   176,   177,   178,   106,   130,
      99,   100,   101,   109,   186,   111,   107,   127,   139,   148,
     106,   193,   281,   195,   168,   169,   170,   171,   172,   173,
     174,   175,   176,   177,   178,   179,   180,   181,   182,   183,
     184,   185,   109,   210,   111,   266,   267,   118,   119,    26,
      99,   100,   101,   122,   123,   124,     7,   109,     9,   111,
     108,    38,    39,    40,    41,    42,    17,   109,   108,   111,
      21,   125,   109,    50,   111,   108,   205,    28,   299,   203,
     126,    32,   303,   304,    75,   206,    37,   109,    26,   111,
     262,    68,   108,    70,    45,   114,   109,    48,   111,   108,
      38,    39,    40,    41,    42,   171,   172,   108,   173,   174,
     100,   111,    50,   285,   286,   111,    67,   179,   180,   108,
      71,   242,    72,   100,   104,   249,   104,   109,   109,     7,
      68,     9,    70,   254,   108,   279,    14,   113,   293,    17,
      18,    19,   111,    21,    22,   266,   267,   111,   277,   109,
      28,   104,    16,   105,    32,   113,   107,    35,    12,    37,
      26,   140,   100,    22,     1,   272,    66,    45,    84,   242,
      48,    70,    38,    39,    40,    41,    42,   237,   299,   181,
     183,   185,   303,   304,    50,   182,   184,    65,    66,    67,
      -1,    -1,    -1,    71,    72,    73,    74,    -1,    -1,    -1,
      -1,    -1,    68,    -1,    70,    -1,    38,    39,    40,    41,
      42,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    50,    -1,
      -1,    99,    -1,    -1,    -1,   103,   104,   105,   106,   107,
     108,    -1,    -1,    -1,   100,    -1,    -1,     7,    70,     9,
     118,   119,   120,   121,    14,    -1,    -1,    17,    18,    19,
      -1,    21,    22,    -1,    -1,    -1,    -1,    -1,    28,    -1,
      -1,    -1,    32,    -1,    -1,    35,    -1,    37,   100,    -1,
      -1,    -1,    79,    -1,    81,    45,    -1,    -1,    48,    86,
      87,    88,    89,    90,    91,    92,    93,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    65,    66,    67,    -1,    -1,
      -1,    71,    72,    73,    74,    -1,    -1,   114,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,     7,    -1,     9,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    17,    18,    -1,    99,
      21,    -1,    -1,   103,   104,   105,   106,    28,   108,    -1,
      -1,    32,    -1,    -1,    -1,    -1,    37,    -1,   118,   119,
     120,   121,    -1,    -1,    45,    -1,     7,    48,     9,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    17,    18,    -1,    -1,
      21,    -1,    -1,    -1,    65,    -1,    67,    28,    -1,    -1,
      71,    32,    73,    74,    -1,    -1,    37,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    45,    -1,    -1,    48,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    99,    -1,
      -1,    -1,   103,   104,    65,   106,    67,   108,    -1,    -1,
      71,    -1,    73,    74,    -1,    -1,    -1,   118,   119,   120,
     121,    -1,    -1,    -1,    -1,     7,    -1,     9,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    17,    18,    -1,    99,    21,
      -1,    -1,   103,   104,   105,    -1,    28,   108,    -1,    -1,
      32,    -1,    -1,    -1,    -1,    37,    -1,   118,   119,   120,
     121,    -1,    -1,    45,    -1,    -1,    48,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,     0,
      -1,    -1,    -1,    65,    -1,    67,     7,    -1,     9,    71,
      -1,    73,    74,    -1,    -1,    -1,    17,    -1,    -1,    -1,
      21,    -1,    -1,    -1,    -1,    -1,    -1,    28,    -1,    -1,
      -1,    32,    -1,    -1,    -1,    -1,    37,    99,    -1,    -1,
      -1,   103,   104,    -1,    45,    -1,   108,    48,    -1,    -1,
      -1,    -1,    -1,     7,    -1,     9,   118,   119,   120,   121,
      -1,    -1,    -1,    17,    -1,    66,    67,    21,    -1,    23,
      71,    25,    -1,    -1,    28,    29,    -1,    -1,    32,    -1,
      -1,    -1,     7,    37,     9,    -1,    -1,    -1,    -1,    -1,
      -1,    45,    17,    -1,    48,    -1,    21,    98,    -1,    -1,
      -1,    -1,    -1,    28,    -1,    -1,    -1,    32,    -1,    -1,
      -1,    -1,    37,    67,    -1,    -1,    -1,    71,    -1,    -1,
      45,    -1,    -1,    48,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    67,    -1,    -1,    -1,    71
};

/* YYSTOS[STATE-NUM] -- The (internal number of the) accessing
   symbol of state STATE-NUM.  */
static const yytype_uint8 yystos[] =
{
       0,   130,     0,     7,     9,    17,    21,    28,    32,    37,
      45,    48,    66,    67,    71,    98,   131,   132,   133,   134,
     135,   139,   140,   152,   153,   156,   161,   161,   161,   161,
     161,   161,   161,   161,   161,   161,   133,   161,   161,   161,
     102,    99,   100,   101,   136,   157,   158,   159,   105,   106,
     141,    26,    38,    39,    40,    41,    42,    50,    68,    70,
     100,   150,   151,   136,   154,   155,   150,   115,   160,   105,
     111,   107,   142,   112,   100,   106,   136,   112,    99,   101,
     143,   158,   160,   105,   111,   154,    18,    65,    73,    74,
      99,   103,   104,   108,   118,   119,   120,   121,   161,   165,
     173,   174,   175,   176,   177,   178,   179,   180,   181,   182,
     183,   184,   185,   186,   187,   188,   189,   191,   110,   144,
     159,    14,    19,    22,    35,    72,   105,   141,   152,   161,
     166,   167,   168,   169,   171,   172,   191,    50,   151,   137,
     106,   151,   108,   105,   155,   105,   176,   176,   161,   191,
     150,    73,    74,   115,   117,    79,    81,    86,    87,    88,
      89,    90,    91,    92,    93,   114,   190,   176,   122,   123,
     124,   118,   119,    78,    80,    83,    84,   112,   113,    77,
      85,   125,   126,   127,    75,    76,   128,   111,   116,   136,
     114,   167,   108,   108,   191,   108,   150,   107,   167,   105,
     100,   111,   107,   135,   138,   161,   137,   111,   142,   145,
     150,   109,   108,   191,   136,   189,   176,   176,   176,   176,
     178,   178,   179,   179,   180,   180,   180,   180,   181,   181,
     182,   183,   184,   185,   186,   191,   189,   106,   162,   163,
     189,    72,   142,   191,   105,   191,   104,   158,    50,   150,
     107,   104,   146,   147,   148,   109,   160,   163,   164,   116,
     110,   164,   108,   156,   161,   172,   109,   109,   111,   105,
     158,   113,   111,    23,    25,    29,   149,   161,   144,   109,
     109,   111,   189,   107,   191,   172,   172,   167,   170,   167,
     104,   105,   147,   150,   176,   163,   109,   191,   191,    16,
     113,   136,   105,   109,   109,   167,   144,   167,   167
};

#define yyerrok		(yyerrstatus = 0)
#define yyclearin	(yychar = YYEMPTY)
#define YYEMPTY		(-2)
#define YYEOF		0

#define YYACCEPT	goto yyacceptlab
#define YYABORT		goto yyabortlab
#define YYERROR		goto yyerrorlab


/* Like YYERROR except do call yyerror.  This remains here temporarily
   to ease the transition to the new meaning of YYERROR, for GCC.
   Once GCC version 2 has supplanted version 1, this can go.  However,
   YYFAIL appears to be in use.  Nevertheless, it is formally deprecated
   in Bison 2.4.2's NEWS entry, where a plan to phase it out is
   discussed.  */

#define YYFAIL		goto yyerrlab
#if defined YYFAIL
  /* This is here to suppress warnings from the GCC cpp's
     -Wunused-macros.  Normally we don't worry about that warning, but
     some users do, and we want to make it easy for users to remove
     YYFAIL uses, which will produce warnings from Bison 2.5.  */
#endif

#define YYRECOVERING()  (!!yyerrstatus)

#define YYBACKUP(Token, Value)					\
do								\
  if (yychar == YYEMPTY && yylen == 1)				\
    {								\
      yychar = (Token);						\
      yylval = (Value);						\
      yytoken = YYTRANSLATE (yychar);				\
      YYPOPSTACK (1);						\
      goto yybackup;						\
    }								\
  else								\
    {								\
      yyerror (YY_("syntax error: cannot back up")); \
      YYERROR;							\
    }								\
while (YYID (0))


#define YYTERROR	1
#define YYERRCODE	256


/* YYLLOC_DEFAULT -- Set CURRENT to span from RHS[1] to RHS[N].
   If N is 0, then set CURRENT to the empty location which ends
   the previous symbol: RHS[0] (always defined).  */

#define YYRHSLOC(Rhs, K) ((Rhs)[K])
#ifndef YYLLOC_DEFAULT
# define YYLLOC_DEFAULT(Current, Rhs, N)				\
    do									\
      if (YYID (N))                                                    \
	{								\
	  (Current).first_line   = YYRHSLOC (Rhs, 1).first_line;	\
	  (Current).first_column = YYRHSLOC (Rhs, 1).first_column;	\
	  (Current).last_line    = YYRHSLOC (Rhs, N).last_line;		\
	  (Current).last_column  = YYRHSLOC (Rhs, N).last_column;	\
	}								\
      else								\
	{								\
	  (Current).first_line   = (Current).last_line   =		\
	    YYRHSLOC (Rhs, 0).last_line;				\
	  (Current).first_column = (Current).last_column =		\
	    YYRHSLOC (Rhs, 0).last_column;				\
	}								\
    while (YYID (0))
#endif


/* YY_LOCATION_PRINT -- Print the location on the stream.
   This macro was not mandated originally: define only if we know
   we won't break user code: when these are the locations we know.  */

#ifndef YY_LOCATION_PRINT
# if defined YYLTYPE_IS_TRIVIAL && YYLTYPE_IS_TRIVIAL
#  define YY_LOCATION_PRINT(File, Loc)			\
     fprintf (File, "%d.%d-%d.%d",			\
	      (Loc).first_line, (Loc).first_column,	\
	      (Loc).last_line,  (Loc).last_column)
# else
#  define YY_LOCATION_PRINT(File, Loc) ((void) 0)
# endif
#endif


/* YYLEX -- calling `yylex' with the right arguments.  */

#ifdef YYLEX_PARAM
# define YYLEX yylex (YYLEX_PARAM)
#else
# define YYLEX yylex ()
#endif

/* Enable debugging if requested.  */
#if YYDEBUG

# ifndef YYFPRINTF
#  include <stdio.h> /* INFRINGES ON USER NAME SPACE */
#  define YYFPRINTF fprintf
# endif

# define YYDPRINTF(Args)			\
do {						\
  if (yydebug)					\
    YYFPRINTF Args;				\
} while (YYID (0))

# define YY_SYMBOL_PRINT(Title, Type, Value, Location)			  \
do {									  \
  if (yydebug)								  \
    {									  \
      YYFPRINTF (stderr, "%s ", Title);					  \
      yy_symbol_print (stderr,						  \
		  Type, Value, Location); \
      YYFPRINTF (stderr, "\n");						  \
    }									  \
} while (YYID (0))


/*--------------------------------.
| Print this symbol on YYOUTPUT.  |
`--------------------------------*/

/*ARGSUSED*/
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yy_symbol_value_print (FILE *yyoutput, int yytype, YYSTYPE const * const yyvaluep, YYLTYPE const * const yylocationp)
#else
static void
yy_symbol_value_print (yyoutput, yytype, yyvaluep, yylocationp)
    FILE *yyoutput;
    int yytype;
    YYSTYPE const * const yyvaluep;
    YYLTYPE const * const yylocationp;
#endif
{
  if (!yyvaluep)
    return;
  YYUSE (yylocationp);
# ifdef YYPRINT
  if (yytype < YYNTOKENS)
    YYPRINT (yyoutput, yytoknum[yytype], *yyvaluep);
# else
  YYUSE (yyoutput);
# endif
  switch (yytype)
    {
      default:
	break;
    }
}


/*--------------------------------.
| Print this symbol on YYOUTPUT.  |
`--------------------------------*/

#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yy_symbol_print (FILE *yyoutput, int yytype, YYSTYPE const * const yyvaluep, YYLTYPE const * const yylocationp)
#else
static void
yy_symbol_print (yyoutput, yytype, yyvaluep, yylocationp)
    FILE *yyoutput;
    int yytype;
    YYSTYPE const * const yyvaluep;
    YYLTYPE const * const yylocationp;
#endif
{
  if (yytype < YYNTOKENS)
    YYFPRINTF (yyoutput, "token %s (", yytname[yytype]);
  else
    YYFPRINTF (yyoutput, "nterm %s (", yytname[yytype]);

  YY_LOCATION_PRINT (yyoutput, *yylocationp);
  YYFPRINTF (yyoutput, ": ");
  yy_symbol_value_print (yyoutput, yytype, yyvaluep, yylocationp);
  YYFPRINTF (yyoutput, ")");
}

/*------------------------------------------------------------------.
| yy_stack_print -- Print the state stack from its BOTTOM up to its |
| TOP (included).                                                   |
`------------------------------------------------------------------*/

#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yy_stack_print (yytype_int16 *yybottom, yytype_int16 *yytop)
#else
static void
yy_stack_print (yybottom, yytop)
    yytype_int16 *yybottom;
    yytype_int16 *yytop;
#endif
{
  YYFPRINTF (stderr, "Stack now");
  for (; yybottom <= yytop; yybottom++)
    {
      int yybot = *yybottom;
      YYFPRINTF (stderr, " %d", yybot);
    }
  YYFPRINTF (stderr, "\n");
}

# define YY_STACK_PRINT(Bottom, Top)				\
do {								\
  if (yydebug)							\
    yy_stack_print ((Bottom), (Top));				\
} while (YYID (0))


/*------------------------------------------------.
| Report that the YYRULE is going to be reduced.  |
`------------------------------------------------*/

#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yy_reduce_print (YYSTYPE *yyvsp, YYLTYPE *yylsp, int yyrule)
#else
static void
yy_reduce_print (yyvsp, yylsp, yyrule)
    YYSTYPE *yyvsp;
    YYLTYPE *yylsp;
    int yyrule;
#endif
{
  int yynrhs = yyr2[yyrule];
  int yyi;
  unsigned long int yylno = yyrline[yyrule];
  YYFPRINTF (stderr, "Reducing stack by rule %d (line %lu):\n",
	     yyrule - 1, yylno);
  /* The symbols being reduced.  */
  for (yyi = 0; yyi < yynrhs; yyi++)
    {
      YYFPRINTF (stderr, "   $%d = ", yyi + 1);
      yy_symbol_print (stderr, yyrhs[yyprhs[yyrule] + yyi],
		       &(yyvsp[(yyi + 1) - (yynrhs)])
		       , &(yylsp[(yyi + 1) - (yynrhs)])		       );
      YYFPRINTF (stderr, "\n");
    }
}

# define YY_REDUCE_PRINT(Rule)		\
do {					\
  if (yydebug)				\
    yy_reduce_print (yyvsp, yylsp, Rule); \
} while (YYID (0))

/* Nonzero means print parse trace.  It is left uninitialized so that
   multiple parsers can coexist.  */
int yydebug;
#else /* !YYDEBUG */
# define YYDPRINTF(Args)
# define YY_SYMBOL_PRINT(Title, Type, Value, Location)
# define YY_STACK_PRINT(Bottom, Top)
# define YY_REDUCE_PRINT(Rule)
#endif /* !YYDEBUG */


/* YYINITDEPTH -- initial size of the parser's stacks.  */
#ifndef	YYINITDEPTH
# define YYINITDEPTH 200
#endif

/* YYMAXDEPTH -- maximum size the stacks can grow to (effective only
   if the built-in stack extension method is used).

   Do not make this value too large; the results are undefined if
   YYSTACK_ALLOC_MAXIMUM < YYSTACK_BYTES (YYMAXDEPTH)
   evaluated with infinite-precision integer arithmetic.  */

#ifndef YYMAXDEPTH
# define YYMAXDEPTH 10000
#endif



#if YYERROR_VERBOSE

# ifndef yystrlen
#  if defined __GLIBC__ && defined _STRING_H
#   define yystrlen strlen
#  else
/* Return the length of YYSTR.  */
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static YYSIZE_T
yystrlen (const char *yystr)
#else
static YYSIZE_T
yystrlen (yystr)
    const char *yystr;
#endif
{
  YYSIZE_T yylen;
  for (yylen = 0; yystr[yylen]; yylen++)
    continue;
  return yylen;
}
#  endif
# endif

# ifndef yystpcpy
#  if defined __GLIBC__ && defined _STRING_H && defined _GNU_SOURCE
#   define yystpcpy stpcpy
#  else
/* Copy YYSRC to YYDEST, returning the address of the terminating '\0' in
   YYDEST.  */
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static char *
yystpcpy (char *yydest, const char *yysrc)
#else
static char *
yystpcpy (yydest, yysrc)
    char *yydest;
    const char *yysrc;
#endif
{
  char *yyd = yydest;
  const char *yys = yysrc;

  while ((*yyd++ = *yys++) != '\0')
    continue;

  return yyd - 1;
}
#  endif
# endif

# ifndef yytnamerr
/* Copy to YYRES the contents of YYSTR after stripping away unnecessary
   quotes and backslashes, so that it's suitable for yyerror.  The
   heuristic is that double-quoting is unnecessary unless the string
   contains an apostrophe, a comma, or backslash (other than
   backslash-backslash).  YYSTR is taken from yytname.  If YYRES is
   null, do not copy; instead, return the length of what the result
   would have been.  */
static YYSIZE_T
yytnamerr (char *yyres, const char *yystr)
{
  if (*yystr == '"')
    {
      YYSIZE_T yyn = 0;
      char const *yyp = yystr;

      for (;;)
	switch (*++yyp)
	  {
	  case '\'':
	  case ',':
	    goto do_not_strip_quotes;

	  case '\\':
	    if (*++yyp != '\\')
	      goto do_not_strip_quotes;
	    /* Fall through.  */
	  default:
	    if (yyres)
	      yyres[yyn] = *yyp;
	    yyn++;
	    break;

	  case '"':
	    if (yyres)
	      yyres[yyn] = '\0';
	    return yyn;
	  }
    do_not_strip_quotes: ;
    }

  if (! yyres)
    return yystrlen (yystr);

  return yystpcpy (yyres, yystr) - yyres;
}
# endif

/* Copy into YYRESULT an error message about the unexpected token
   YYCHAR while in state YYSTATE.  Return the number of bytes copied,
   including the terminating null byte.  If YYRESULT is null, do not
   copy anything; just return the number of bytes that would be
   copied.  As a special case, return 0 if an ordinary "syntax error"
   message will do.  Return YYSIZE_MAXIMUM if overflow occurs during
   size calculation.  */
static YYSIZE_T
yysyntax_error (char *yyresult, int yystate, int yychar)
{
  int yyn = yypact[yystate];

  if (! (YYPACT_NINF < yyn && yyn <= YYLAST))
    return 0;
  else
    {
      int yytype = YYTRANSLATE (yychar);
      YYSIZE_T yysize0 = yytnamerr (0, yytname[yytype]);
      YYSIZE_T yysize = yysize0;
      YYSIZE_T yysize1;
      int yysize_overflow = 0;
      enum { YYERROR_VERBOSE_ARGS_MAXIMUM = 5 };
      char const *yyarg[YYERROR_VERBOSE_ARGS_MAXIMUM];
      int yyx;

# if 0
      /* This is so xgettext sees the translatable formats that are
	 constructed on the fly.  */
      YY_("syntax error, unexpected %s");
      YY_("syntax error, unexpected %s, expecting %s");
      YY_("syntax error, unexpected %s, expecting %s or %s");
      YY_("syntax error, unexpected %s, expecting %s or %s or %s");
      YY_("syntax error, unexpected %s, expecting %s or %s or %s or %s");
# endif
      char *yyfmt;
      char const *yyf;
      static char const yyunexpected[] = "syntax error, unexpected %s";
      static char const yyexpecting[] = ", expecting %s";
      static char const yyor[] = " or %s";
      char yyformat[sizeof yyunexpected
		    + sizeof yyexpecting - 1
		    + ((YYERROR_VERBOSE_ARGS_MAXIMUM - 2)
		       * (sizeof yyor - 1))];
      char const *yyprefix = yyexpecting;

      /* Start YYX at -YYN if negative to avoid negative indexes in
	 YYCHECK.  */
      int yyxbegin = yyn < 0 ? -yyn : 0;

      /* Stay within bounds of both yycheck and yytname.  */
      int yychecklim = YYLAST - yyn + 1;
      int yyxend = yychecklim < YYNTOKENS ? yychecklim : YYNTOKENS;
      int yycount = 1;

      yyarg[0] = yytname[yytype];
      yyfmt = yystpcpy (yyformat, yyunexpected);

      for (yyx = yyxbegin; yyx < yyxend; ++yyx)
	if (yycheck[yyx + yyn] == yyx && yyx != YYTERROR)
	  {
	    if (yycount == YYERROR_VERBOSE_ARGS_MAXIMUM)
	      {
		yycount = 1;
		yysize = yysize0;
		yyformat[sizeof yyunexpected - 1] = '\0';
		break;
	      }
	    yyarg[yycount++] = yytname[yyx];
	    yysize1 = yysize + yytnamerr (0, yytname[yyx]);
	    yysize_overflow |= (yysize1 < yysize);
	    yysize = yysize1;
	    yyfmt = yystpcpy (yyfmt, yyprefix);
	    yyprefix = yyor;
	  }

      yyf = YY_(yyformat);
      yysize1 = yysize + yystrlen (yyf);
      yysize_overflow |= (yysize1 < yysize);
      yysize = yysize1;

      if (yysize_overflow)
	return YYSIZE_MAXIMUM;

      if (yyresult)
	{
	  /* Avoid sprintf, as that infringes on the user's name space.
	     Don't have undefined behavior even if the translation
	     produced a string with the wrong number of "%s"s.  */
	  char *yyp = yyresult;
	  int yyi = 0;
	  while ((*yyp = *yyf) != '\0')
	    {
	      if (*yyp == '%' && yyf[1] == 's' && yyi < yycount)
		{
		  yyp += yytnamerr (yyp, yyarg[yyi++]);
		  yyf += 2;
		}
	      else
		{
		  yyp++;
		  yyf++;
		}
	    }
	}
      return yysize;
    }
}
#endif /* YYERROR_VERBOSE */


/*-----------------------------------------------.
| Release the memory associated to this symbol.  |
`-----------------------------------------------*/

/*ARGSUSED*/
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yydestruct (const char *yymsg, int yytype, YYSTYPE *yyvaluep, YYLTYPE *yylocationp)
#else
static void
yydestruct (yymsg, yytype, yyvaluep, yylocationp)
    const char *yymsg;
    int yytype;
    YYSTYPE *yyvaluep;
    YYLTYPE *yylocationp;
#endif
{
  YYUSE (yyvaluep);
  YYUSE (yylocationp);

  if (!yymsg)
    yymsg = "Deleting";
  YY_SYMBOL_PRINT (yymsg, yytype, yyvaluep, yylocationp);

  switch (yytype)
    {

      default:
	break;
    }
}

/* Prevent warnings from -Wmissing-prototypes.  */
#ifdef YYPARSE_PARAM
#if defined __STDC__ || defined __cplusplus
int yyparse (void *YYPARSE_PARAM);
#else
int yyparse ();
#endif
#else /* ! YYPARSE_PARAM */
#if defined __STDC__ || defined __cplusplus
int yyparse (void);
#else
int yyparse ();
#endif
#endif /* ! YYPARSE_PARAM */


/* The lookahead symbol.  */
int yychar;

/* The semantic value of the lookahead symbol.  */
YYSTYPE yylval;

/* Location data for the lookahead symbol.  */
YYLTYPE yylloc;

/* Number of syntax errors so far.  */
int yynerrs;



/*-------------------------.
| yyparse or yypush_parse.  |
`-------------------------*/

#ifdef YYPARSE_PARAM
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
int
yyparse (void *YYPARSE_PARAM)
#else
int
yyparse (YYPARSE_PARAM)
    void *YYPARSE_PARAM;
#endif
#else /* ! YYPARSE_PARAM */
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
int
yyparse (void)
#else
int
yyparse ()

#endif
#endif
{


    int yystate;
    /* Number of tokens to shift before error messages enabled.  */
    int yyerrstatus;

    /* The stacks and their tools:
       `yyss': related to states.
       `yyvs': related to semantic values.
       `yyls': related to locations.

       Refer to the stacks thru separate pointers, to allow yyoverflow
       to reallocate them elsewhere.  */

    /* The state stack.  */
    yytype_int16 yyssa[YYINITDEPTH];
    yytype_int16 *yyss;
    yytype_int16 *yyssp;

    /* The semantic value stack.  */
    YYSTYPE yyvsa[YYINITDEPTH];
    YYSTYPE *yyvs;
    YYSTYPE *yyvsp;

    /* The location stack.  */
    YYLTYPE yylsa[YYINITDEPTH];
    YYLTYPE *yyls;
    YYLTYPE *yylsp;

    /* The locations where the error started and ended.  */
    YYLTYPE yyerror_range[2];

    YYSIZE_T yystacksize;

  int yyn;
  int yyresult;
  /* Lookahead token as an internal (translated) token number.  */
  int yytoken;
  /* The variables used to return semantic value and location from the
     action routines.  */
  YYSTYPE yyval;
  YYLTYPE yyloc;

#if YYERROR_VERBOSE
  /* Buffer for error messages, and its allocated size.  */
  char yymsgbuf[128];
  char *yymsg = yymsgbuf;
  YYSIZE_T yymsg_alloc = sizeof yymsgbuf;
#endif

#define YYPOPSTACK(N)   (yyvsp -= (N), yyssp -= (N), yylsp -= (N))

  /* The number of symbols on the RHS of the reduced rule.
     Keep to zero when no symbol should be popped.  */
  int yylen = 0;

  yytoken = 0;
  yyss = yyssa;
  yyvs = yyvsa;
  yyls = yylsa;
  yystacksize = YYINITDEPTH;

  YYDPRINTF ((stderr, "Starting parse\n"));

  yystate = 0;
  yyerrstatus = 0;
  yynerrs = 0;
  yychar = YYEMPTY; /* Cause a token to be read.  */

  /* Initialize stack pointers.
     Waste one element of value and location stack
     so that they stay on the same level as the state stack.
     The wasted elements are never initialized.  */
  yyssp = yyss;
  yyvsp = yyvs;
  yylsp = yyls;

#if defined YYLTYPE_IS_TRIVIAL && YYLTYPE_IS_TRIVIAL
  /* Initialize the default location before parsing starts.  */
  yylloc.first_line   = yylloc.last_line   = 1;
  yylloc.first_column = yylloc.last_column = 1;
#endif

  goto yysetstate;

/*------------------------------------------------------------.
| yynewstate -- Push a new state, which is found in yystate.  |
`------------------------------------------------------------*/
 yynewstate:
  /* In all cases, when you get here, the value and location stacks
     have just been pushed.  So pushing a state here evens the stacks.  */
  yyssp++;

 yysetstate:
  *yyssp = yystate;

  if (yyss + yystacksize - 1 <= yyssp)
    {
      /* Get the current used size of the three stacks, in elements.  */
      YYSIZE_T yysize = yyssp - yyss + 1;

#ifdef yyoverflow
      {
	/* Give user a chance to reallocate the stack.  Use copies of
	   these so that the &'s don't force the real ones into
	   memory.  */
	YYSTYPE *yyvs1 = yyvs;
	yytype_int16 *yyss1 = yyss;
	YYLTYPE *yyls1 = yyls;

	/* Each stack pointer address is followed by the size of the
	   data in use in that stack, in bytes.  This used to be a
	   conditional around just the two extra args, but that might
	   be undefined if yyoverflow is a macro.  */
	yyoverflow (YY_("memory exhausted"),
		    &yyss1, yysize * sizeof (*yyssp),
		    &yyvs1, yysize * sizeof (*yyvsp),
		    &yyls1, yysize * sizeof (*yylsp),
		    &yystacksize);

	yyls = yyls1;
	yyss = yyss1;
	yyvs = yyvs1;
      }
#else /* no yyoverflow */
# ifndef YYSTACK_RELOCATE
      goto yyexhaustedlab;
# else
      /* Extend the stack our own way.  */
      if (YYMAXDEPTH <= yystacksize)
	goto yyexhaustedlab;
      yystacksize *= 2;
      if (YYMAXDEPTH < yystacksize)
	yystacksize = YYMAXDEPTH;

      {
	yytype_int16 *yyss1 = yyss;
	union yyalloc *yyptr =
	  (union yyalloc *) YYSTACK_ALLOC (YYSTACK_BYTES (yystacksize));
	if (! yyptr)
	  goto yyexhaustedlab;
	YYSTACK_RELOCATE (yyss_alloc, yyss);
	YYSTACK_RELOCATE (yyvs_alloc, yyvs);
	YYSTACK_RELOCATE (yyls_alloc, yyls);
#  undef YYSTACK_RELOCATE
	if (yyss1 != yyssa)
	  YYSTACK_FREE (yyss1);
      }
# endif
#endif /* no yyoverflow */

      yyssp = yyss + yysize - 1;
      yyvsp = yyvs + yysize - 1;
      yylsp = yyls + yysize - 1;

      YYDPRINTF ((stderr, "Stack size increased to %lu\n",
		  (unsigned long int) yystacksize));

      if (yyss + yystacksize - 1 <= yyssp)
	YYABORT;
    }

  YYDPRINTF ((stderr, "Entering state %d\n", yystate));

  if (yystate == YYFINAL)
    YYACCEPT;

  goto yybackup;

/*-----------.
| yybackup.  |
`-----------*/
yybackup:

  /* Do appropriate processing given the current state.  Read a
     lookahead token if we need one and don't already have one.  */

  /* First try to decide what to do without reference to lookahead token.  */
  yyn = yypact[yystate];
  if (yyn == YYPACT_NINF)
    goto yydefault;

  /* Not known => get a lookahead token if don't already have one.  */

  /* YYCHAR is either YYEMPTY or YYEOF or a valid lookahead symbol.  */
  if (yychar == YYEMPTY)
    {
      YYDPRINTF ((stderr, "Reading a token: "));
      yychar = YYLEX;
    }

  if (yychar <= YYEOF)
    {
      yychar = yytoken = YYEOF;
      YYDPRINTF ((stderr, "Now at end of input.\n"));
    }
  else
    {
      yytoken = YYTRANSLATE (yychar);
      YY_SYMBOL_PRINT ("Next token is", yytoken, &yylval, &yylloc);
    }

  /* If the proper action on seeing token YYTOKEN is to reduce or to
     detect an error, take that action.  */
  yyn += yytoken;
  if (yyn < 0 || YYLAST < yyn || yycheck[yyn] != yytoken)
    goto yydefault;
  yyn = yytable[yyn];
  if (yyn <= 0)
    {
      if (yyn == 0 || yyn == YYTABLE_NINF)
	goto yyerrlab;
      yyn = -yyn;
      goto yyreduce;
    }

  /* Count tokens shifted since error; after three, turn off error
     status.  */
  if (yyerrstatus)
    yyerrstatus--;

  /* Shift the lookahead token.  */
  YY_SYMBOL_PRINT ("Shifting", yytoken, &yylval, &yylloc);

  /* Discard the shifted token.  */
  yychar = YYEMPTY;

  yystate = yyn;
  *++yyvsp = yylval;
  *++yylsp = yylloc;
  goto yynewstate;


/*-----------------------------------------------------------.
| yydefault -- do the default action for the current state.  |
`-----------------------------------------------------------*/
yydefault:
  yyn = yydefact[yystate];
  if (yyn == 0)
    goto yyerrlab;
  goto yyreduce;


/*-----------------------------.
| yyreduce -- Do a reduction.  |
`-----------------------------*/
yyreduce:
  /* yyn is the number of a rule to reduce with.  */
  yylen = yyr2[yyn];

  /* If YYLEN is nonzero, implement the default value of the action:
     `$$ = $1'.

     Otherwise, the following line sets YYVAL to garbage.
     This behavior is undocumented and Bison
     users should not rely upon it.  Assigning to YYVAL
     unconditionally makes the parser a bit smaller, and it avoids a
     GCC warning that YYVAL may be used uninitialized.  */
  yyval = yyvsp[1-yylen];

  /* Default location.  */
  YYLLOC_DEFAULT (yyloc, (yylsp - yylen), yylen);
  YY_REDUCE_PRINT (yyn);
  switch (yyn)
    {
        case 2:

/* Line 1464 of yacc.c  */
#line 1022 "hlsl.y"
    {
                            ;}
    break;

  case 3:

/* Line 1464 of yacc.c  */
#line 1025 "hlsl.y"
    {
                                const struct hlsl_ir_function_decl *decl;

                                decl = get_overloaded_func(&hlsl_ctx.functions, (yyvsp[(2) - (2)].function).name, (yyvsp[(2) - (2)].function).decl->parameters, TRUE);
                                if (decl && !decl->func->intrinsic)
                                {
                                    if (decl->body && (yyvsp[(2) - (2)].function).decl->body)
                                    {
                                        hlsl_report_message((yyvsp[(2) - (2)].function).decl->node.loc.file, (yyvsp[(2) - (2)].function).decl->node.loc.line,
                                                (yyvsp[(2) - (2)].function).decl->node.loc.col, HLSL_LEVEL_ERROR,
                                                "redefinition of function %s", debugstr_a((yyvsp[(2) - (2)].function).name));
                                        return 1;
                                    }
                                    else if (!compare_hlsl_types(decl->node.data_type, (yyvsp[(2) - (2)].function).decl->node.data_type))
                                    {
                                        hlsl_report_message((yyvsp[(2) - (2)].function).decl->node.loc.file, (yyvsp[(2) - (2)].function).decl->node.loc.line,
                                                (yyvsp[(2) - (2)].function).decl->node.loc.col, HLSL_LEVEL_ERROR,
                                                "redefining function %s with a different return type",
                                                debugstr_a((yyvsp[(2) - (2)].function).name));
                                        hlsl_report_message(decl->node.loc.file, decl->node.loc.line, decl->node.loc.col, HLSL_LEVEL_NOTE,
                                                "%s previously declared here",
                                                debugstr_a((yyvsp[(2) - (2)].function).name));
                                        return 1;
                                    }
                                }

                                if ((yyvsp[(2) - (2)].function).decl->node.data_type->base_type == HLSL_TYPE_VOID && (yyvsp[(2) - (2)].function).decl->semantic)
                                {
                                    hlsl_report_message((yyvsp[(2) - (2)].function).decl->node.loc.file, (yyvsp[(2) - (2)].function).decl->node.loc.line,
                                            (yyvsp[(2) - (2)].function).decl->node.loc.col, HLSL_LEVEL_ERROR,
                                            "void function with a semantic");
                                }

                                TRACE("Adding function '%s' to the function list.\n", (yyvsp[(2) - (2)].function).name);
                                add_function_decl(&hlsl_ctx.functions, (yyvsp[(2) - (2)].function).name, (yyvsp[(2) - (2)].function).decl, FALSE);
                            ;}
    break;

  case 4:

/* Line 1464 of yacc.c  */
#line 1062 "hlsl.y"
    {
                                TRACE("Declaration statement parsed.\n");
                            ;}
    break;

  case 5:

/* Line 1464 of yacc.c  */
#line 1066 "hlsl.y"
    {
                            ;}
    break;

  case 6:

/* Line 1464 of yacc.c  */
#line 1070 "hlsl.y"
    {
                                TRACE("Updating line information to file %s, line %u\n", debugstr_a((yyvsp[(2) - (2)].name)), (yyvsp[(1) - (2)].intval));
                                hlsl_ctx.line_no = (yyvsp[(1) - (2)].intval);
                                if (strcmp((yyvsp[(2) - (2)].name), hlsl_ctx.source_file))
                                {
                                    const char **new_array;

                                    hlsl_ctx.source_file = (yyvsp[(2) - (2)].name);
                                    new_array = d3dcompiler_realloc(hlsl_ctx.source_files,
                                            sizeof(*hlsl_ctx.source_files) * hlsl_ctx.source_files_count + 1);
                                    if (new_array)
                                    {
                                        hlsl_ctx.source_files = new_array;
                                        hlsl_ctx.source_files[hlsl_ctx.source_files_count++] = (yyvsp[(2) - (2)].name);
                                    }
                                }
                            ;}
    break;

  case 7:

/* Line 1464 of yacc.c  */
#line 1089 "hlsl.y"
    {
                                struct source_location loc;

                                set_location(&loc, &(yylsp[(3) - (3)]));
                                if (!(yyvsp[(2) - (3)].list))
                                {
                                    if (!(yyvsp[(1) - (3)].type)->name)
                                    {
                                        hlsl_report_message(loc.file, loc.line, loc.col,
                                                HLSL_LEVEL_ERROR, "anonymous struct declaration with no variables");
                                    }
                                    check_type_modifiers((yyvsp[(1) - (3)].type)->modifiers, &loc);
                                }
                                (yyval.list) = declare_vars((yyvsp[(1) - (3)].type), 0, (yyvsp[(2) - (3)].list));
                            ;}
    break;

  case 10:

/* Line 1464 of yacc.c  */
#line 1109 "hlsl.y"
    {
                                BOOL ret;
                                struct source_location loc;

                                TRACE("Structure %s declaration.\n", debugstr_a((yyvsp[(3) - (6)].name)));
                                set_location(&loc, &(yylsp[(1) - (6)]));
                                check_invalid_matrix_modifiers((yyvsp[(1) - (6)].modifiers), &loc);
                                (yyval.type) = new_struct_type((yyvsp[(3) - (6)].name), (yyvsp[(1) - (6)].modifiers), (yyvsp[(5) - (6)].list));

                                if (get_variable(hlsl_ctx.cur_scope, (yyvsp[(3) - (6)].name)))
                                {
                                    hlsl_report_message(hlsl_ctx.source_file, (yylsp[(3) - (6)]).first_line, (yylsp[(3) - (6)]).first_column,
                                            HLSL_LEVEL_ERROR, "redefinition of '%s'", (yyvsp[(3) - (6)].name));
                                    return 1;
                                }

                                ret = add_type_to_scope(hlsl_ctx.cur_scope, (yyval.type));
                                if (!ret)
                                {
                                    hlsl_report_message(hlsl_ctx.source_file, (yylsp[(3) - (6)]).first_line, (yylsp[(3) - (6)]).first_column,
                                            HLSL_LEVEL_ERROR, "redefinition of struct '%s'", (yyvsp[(3) - (6)].name));
                                    return 1;
                                }
                            ;}
    break;

  case 11:

/* Line 1464 of yacc.c  */
#line 1135 "hlsl.y"
    {
                                struct source_location loc;

                                TRACE("Anonymous structure declaration.\n");
                                set_location(&loc, &(yylsp[(1) - (5)]));
                                check_invalid_matrix_modifiers((yyvsp[(1) - (5)].modifiers), &loc);
                                (yyval.type) = new_struct_type(NULL, (yyvsp[(1) - (5)].modifiers), (yyvsp[(4) - (5)].list));
                            ;}
    break;

  case 15:

/* Line 1464 of yacc.c  */
#line 1149 "hlsl.y"
    {
                                (yyval.list) = d3dcompiler_alloc(sizeof(*(yyval.list)));
                                list_init((yyval.list));
                            ;}
    break;

  case 16:

/* Line 1464 of yacc.c  */
#line 1154 "hlsl.y"
    {
                                BOOL ret;
                                struct hlsl_struct_field *field, *next;

                                (yyval.list) = (yyvsp[(1) - (2)].list);
                                LIST_FOR_EACH_ENTRY_SAFE(field, next, (yyvsp[(2) - (2)].list), struct hlsl_struct_field, entry)
                                {
                                    ret = add_struct_field((yyval.list), field);
                                    if (ret == FALSE)
                                    {
                                        hlsl_report_message(hlsl_ctx.source_file, (yylsp[(2) - (2)]).first_line, (yylsp[(2) - (2)]).first_column,
                                                HLSL_LEVEL_ERROR, "redefinition of '%s'", field->name);
                                        d3dcompiler_free(field);
                                    }
                                }
                                d3dcompiler_free((yyvsp[(2) - (2)].list));
                            ;}
    break;

  case 17:

/* Line 1464 of yacc.c  */
#line 1173 "hlsl.y"
    {
                                (yyval.list) = gen_struct_fields((yyvsp[(2) - (4)].type), (yyvsp[(1) - (4)].modifiers), (yyvsp[(3) - (4)].list));
                            ;}
    break;

  case 18:

/* Line 1464 of yacc.c  */
#line 1177 "hlsl.y"
    {
                                (yyval.list) = gen_struct_fields((yyvsp[(1) - (3)].type), 0, (yyvsp[(2) - (3)].list));
                            ;}
    break;

  case 19:

/* Line 1464 of yacc.c  */
#line 1182 "hlsl.y"
    {
                                TRACE("Function %s parsed.\n", (yyvsp[(1) - (2)].function).name);
                                (yyval.function) = (yyvsp[(1) - (2)].function);
                                (yyval.function).decl->body = (yyvsp[(2) - (2)].list);
                                pop_scope(&hlsl_ctx);
                            ;}
    break;

  case 20:

/* Line 1464 of yacc.c  */
#line 1189 "hlsl.y"
    {
                                TRACE("Function prototype for %s.\n", (yyvsp[(1) - (2)].function).name);
                                (yyval.function) = (yyvsp[(1) - (2)].function);
                                pop_scope(&hlsl_ctx);
                            ;}
    break;

  case 21:

/* Line 1464 of yacc.c  */
#line 1196 "hlsl.y"
    {
                                if (get_variable(hlsl_ctx.globals, (yyvsp[(3) - (7)].name)))
                                {
                                    hlsl_report_message(hlsl_ctx.source_file, (yylsp[(3) - (7)]).first_line, (yylsp[(3) - (7)]).first_column,
                                            HLSL_LEVEL_ERROR, "redefinition of '%s'\n", (yyvsp[(3) - (7)].name));
                                    return 1;
                                }
                                if ((yyvsp[(2) - (7)].type)->base_type == HLSL_TYPE_VOID && (yyvsp[(7) - (7)].name))
                                {
                                    hlsl_report_message(hlsl_ctx.source_file, (yylsp[(7) - (7)]).first_line, (yylsp[(7) - (7)]).first_column,
                                            HLSL_LEVEL_ERROR, "void function with a semantic");
                                }

                                (yyval.function).decl = new_func_decl((yyvsp[(2) - (7)].type), (yyvsp[(5) - (7)].list));
                                if (!(yyval.function).decl)
                                {
                                    ERR("Out of memory.\n");
                                    return -1;
                                }
                                (yyval.function).name = (yyvsp[(3) - (7)].name);
                                (yyval.function).decl->semantic = (yyvsp[(7) - (7)].name);
                                set_location(&(yyval.function).decl->node.loc, &(yylsp[(3) - (7)]));
                            ;}
    break;

  case 22:

/* Line 1464 of yacc.c  */
#line 1221 "hlsl.y"
    {
                                (yyval.list) = d3dcompiler_alloc(sizeof(*(yyval.list)));
                                list_init((yyval.list));
                            ;}
    break;

  case 23:

/* Line 1464 of yacc.c  */
#line 1226 "hlsl.y"
    {
                                pop_scope(&hlsl_ctx);
                                (yyval.list) = (yyvsp[(3) - (4)].list);
                            ;}
    break;

  case 24:

/* Line 1464 of yacc.c  */
#line 1232 "hlsl.y"
    {
                                push_scope(&hlsl_ctx);
                            ;}
    break;

  case 27:

/* Line 1464 of yacc.c  */
#line 1240 "hlsl.y"
    {
                                (yyval.name) = NULL;
                            ;}
    break;

  case 28:

/* Line 1464 of yacc.c  */
#line 1244 "hlsl.y"
    {
                                (yyval.name) = (yyvsp[(2) - (2)].name);
                            ;}
    break;

  case 29:

/* Line 1464 of yacc.c  */
#line 1249 "hlsl.y"
    {
                                (yyval.list) = d3dcompiler_alloc(sizeof(*(yyval.list)));
                                list_init((yyval.list));
                            ;}
    break;

  case 30:

/* Line 1464 of yacc.c  */
#line 1254 "hlsl.y"
    {
                                (yyval.list) = (yyvsp[(2) - (2)].list);
                            ;}
    break;

  case 31:

/* Line 1464 of yacc.c  */
#line 1259 "hlsl.y"
    {
                                struct source_location loc;

                                (yyval.list) = d3dcompiler_alloc(sizeof(*(yyval.list)));
                                list_init((yyval.list));
                                set_location(&loc, &(yylsp[(1) - (1)]));
                                if (!add_func_parameter((yyval.list), &(yyvsp[(1) - (1)].parameter), &loc))
                                {
                                    ERR("Error adding function parameter %s.\n", (yyvsp[(1) - (1)].parameter).name);
                                    set_parse_status(&hlsl_ctx.status, PARSE_ERR);
                                    return -1;
                                }
                            ;}
    break;

  case 32:

/* Line 1464 of yacc.c  */
#line 1273 "hlsl.y"
    {
                                struct source_location loc;

                                (yyval.list) = (yyvsp[(1) - (3)].list);
                                set_location(&loc, &(yylsp[(3) - (3)]));
                                if (!add_func_parameter((yyval.list), &(yyvsp[(3) - (3)].parameter), &loc))
                                {
                                    hlsl_report_message(loc.file, loc.line, loc.col, HLSL_LEVEL_ERROR,
                                            "duplicate parameter %s", (yyvsp[(3) - (3)].parameter).name);
                                    return 1;
                                }
                            ;}
    break;

  case 33:

/* Line 1464 of yacc.c  */
#line 1287 "hlsl.y"
    {
                                (yyval.parameter).modifiers = (yyvsp[(1) - (5)].modifiers) ? (yyvsp[(1) - (5)].modifiers) : HLSL_MODIFIER_IN;
                                (yyval.parameter).modifiers |= (yyvsp[(2) - (5)].modifiers);
                                (yyval.parameter).type = (yyvsp[(3) - (5)].type);
                                (yyval.parameter).name = (yyvsp[(4) - (5)].name);
                                (yyval.parameter).semantic = (yyvsp[(5) - (5)].name);
                            ;}
    break;

  case 34:

/* Line 1464 of yacc.c  */
#line 1296 "hlsl.y"
    {
                                (yyval.modifiers) = 0;
                            ;}
    break;

  case 35:

/* Line 1464 of yacc.c  */
#line 1300 "hlsl.y"
    {
                                if ((yyvsp[(1) - (2)].modifiers) & (yyvsp[(2) - (2)].modifiers))
                                {
                                    hlsl_report_message(hlsl_ctx.source_file, (yylsp[(2) - (2)]).first_line, (yylsp[(2) - (2)]).first_column,
                                            HLSL_LEVEL_ERROR, "duplicate input-output modifiers");
                                    return 1;
                                }
                                (yyval.modifiers) = (yyvsp[(1) - (2)].modifiers) | (yyvsp[(2) - (2)].modifiers);
                            ;}
    break;

  case 36:

/* Line 1464 of yacc.c  */
#line 1311 "hlsl.y"
    {
                                (yyval.modifiers) = HLSL_MODIFIER_IN;
                            ;}
    break;

  case 37:

/* Line 1464 of yacc.c  */
#line 1315 "hlsl.y"
    {
                                (yyval.modifiers) = HLSL_MODIFIER_OUT;
                            ;}
    break;

  case 38:

/* Line 1464 of yacc.c  */
#line 1319 "hlsl.y"
    {
                                (yyval.modifiers) = HLSL_MODIFIER_IN | HLSL_MODIFIER_OUT;
                            ;}
    break;

  case 39:

/* Line 1464 of yacc.c  */
#line 1324 "hlsl.y"
    {
                                (yyval.type) = (yyvsp[(1) - (1)].type);
                            ;}
    break;

  case 40:

/* Line 1464 of yacc.c  */
#line 1328 "hlsl.y"
    {
                                if ((yyvsp[(3) - (6)].type)->type != HLSL_CLASS_SCALAR)
                                {
                                    hlsl_message("Line %u: vectors of non-scalar types are not allowed.\n",
                                            hlsl_ctx.line_no);
                                    set_parse_status(&hlsl_ctx.status, PARSE_ERR);
                                    return 1;
                                }
                                if ((yyvsp[(5) - (6)].intval) < 1 || (yyvsp[(5) - (6)].intval) > 4)
                                {
                                    hlsl_message("Line %u: vector size must be between 1 and 4.\n",
                                            hlsl_ctx.line_no);
                                    set_parse_status(&hlsl_ctx.status, PARSE_ERR);
                                    return 1;
                                }

                                (yyval.type) = new_hlsl_type(NULL, HLSL_CLASS_VECTOR, (yyvsp[(3) - (6)].type)->base_type, (yyvsp[(5) - (6)].intval), 1);
                            ;}
    break;

  case 41:

/* Line 1464 of yacc.c  */
#line 1347 "hlsl.y"
    {
                                if ((yyvsp[(3) - (8)].type)->type != HLSL_CLASS_SCALAR)
                                {
                                    hlsl_message("Line %u: matrices of non-scalar types are not allowed.\n",
                                            hlsl_ctx.line_no);
                                    set_parse_status(&hlsl_ctx.status, PARSE_ERR);
                                    return 1;
                                }
                                if ((yyvsp[(5) - (8)].intval) < 1 || (yyvsp[(5) - (8)].intval) > 4 || (yyvsp[(7) - (8)].intval) < 1 || (yyvsp[(7) - (8)].intval) > 4)
                                {
                                    hlsl_message("Line %u: matrix dimensions must be between 1 and 4.\n",
                                            hlsl_ctx.line_no);
                                    set_parse_status(&hlsl_ctx.status, PARSE_ERR);
                                    return 1;
                                }

                                (yyval.type) = new_hlsl_type(NULL, HLSL_CLASS_MATRIX, (yyvsp[(3) - (8)].type)->base_type, (yyvsp[(5) - (8)].intval), (yyvsp[(7) - (8)].intval));
                            ;}
    break;

  case 42:

/* Line 1464 of yacc.c  */
#line 1367 "hlsl.y"
    {
                                (yyval.type) = new_hlsl_type(d3dcompiler_strdup("void"), HLSL_CLASS_OBJECT, HLSL_TYPE_VOID, 1, 1);
                            ;}
    break;

  case 43:

/* Line 1464 of yacc.c  */
#line 1371 "hlsl.y"
    {
                                (yyval.type) = new_hlsl_type(d3dcompiler_strdup("sampler"), HLSL_CLASS_OBJECT, HLSL_TYPE_SAMPLER, 1, 1);
                                (yyval.type)->sampler_dim = HLSL_SAMPLER_DIM_GENERIC;
                            ;}
    break;

  case 44:

/* Line 1464 of yacc.c  */
#line 1376 "hlsl.y"
    {
                                (yyval.type) = new_hlsl_type(d3dcompiler_strdup("sampler1D"), HLSL_CLASS_OBJECT, HLSL_TYPE_SAMPLER, 1, 1);
                                (yyval.type)->sampler_dim = HLSL_SAMPLER_DIM_1D;
                            ;}
    break;

  case 45:

/* Line 1464 of yacc.c  */
#line 1381 "hlsl.y"
    {
                                (yyval.type) = new_hlsl_type(d3dcompiler_strdup("sampler2D"), HLSL_CLASS_OBJECT, HLSL_TYPE_SAMPLER, 1, 1);
                                (yyval.type)->sampler_dim = HLSL_SAMPLER_DIM_2D;
                            ;}
    break;

  case 46:

/* Line 1464 of yacc.c  */
#line 1386 "hlsl.y"
    {
                                (yyval.type) = new_hlsl_type(d3dcompiler_strdup("sampler3D"), HLSL_CLASS_OBJECT, HLSL_TYPE_SAMPLER, 1, 1);
                                (yyval.type)->sampler_dim = HLSL_SAMPLER_DIM_3D;
                            ;}
    break;

  case 47:

/* Line 1464 of yacc.c  */
#line 1391 "hlsl.y"
    {
                                (yyval.type) = new_hlsl_type(d3dcompiler_strdup("samplerCUBE"), HLSL_CLASS_OBJECT, HLSL_TYPE_SAMPLER, 1, 1);
                                (yyval.type)->sampler_dim = HLSL_SAMPLER_DIM_CUBE;
                            ;}
    break;

  case 48:

/* Line 1464 of yacc.c  */
#line 1396 "hlsl.y"
    {
                                struct hlsl_type *type;

                                TRACE("Type %s.\n", (yyvsp[(1) - (1)].name));
                                type = get_type(hlsl_ctx.cur_scope, (yyvsp[(1) - (1)].name), TRUE);
                                (yyval.type) = type;
                                d3dcompiler_free((yyvsp[(1) - (1)].name));
                            ;}
    break;

  case 49:

/* Line 1464 of yacc.c  */
#line 1405 "hlsl.y"
    {
                                struct hlsl_type *type;

                                TRACE("Struct type %s.\n", (yyvsp[(2) - (2)].name));
                                type = get_type(hlsl_ctx.cur_scope, (yyvsp[(2) - (2)].name), TRUE);
                                if (type->type != HLSL_CLASS_STRUCT)
                                {
                                    hlsl_message("Line %u: redefining %s as a structure.\n",
                                            hlsl_ctx.line_no, (yyvsp[(2) - (2)].name));
                                    set_parse_status(&hlsl_ctx.status, PARSE_ERR);
                                }
                                else
                                {
                                    (yyval.type) = type;
                                }
                                d3dcompiler_free((yyvsp[(2) - (2)].name));
                            ;}
    break;

  case 52:

/* Line 1464 of yacc.c  */
#line 1426 "hlsl.y"
    {
                                (yyval.list) = d3dcompiler_alloc(sizeof(*(yyval.list)));
                                if (!(yyval.list))
                                {
                                    ERR("Out of memory\n");
                                    return -1;
                                }
                                list_init((yyval.list));
                            ;}
    break;

  case 53:

/* Line 1464 of yacc.c  */
#line 1437 "hlsl.y"
    {
                                struct source_location loc;

                                set_location(&loc, &(yylsp[(1) - (5)]));
                                if (!add_typedef((yyvsp[(2) - (5)].modifiers), (yyvsp[(3) - (5)].type), (yyvsp[(4) - (5)].list), &loc))
                                    return 1;
                            ;}
    break;

  case 54:

/* Line 1464 of yacc.c  */
#line 1445 "hlsl.y"
    {
                                struct source_location loc;

                                set_location(&loc, &(yylsp[(1) - (4)]));
                                if (!add_typedef(0, (yyvsp[(2) - (4)].type), (yyvsp[(3) - (4)].list), &loc))
                                    return 1;
                            ;}
    break;

  case 55:

/* Line 1464 of yacc.c  */
#line 1454 "hlsl.y"
    {
                                (yyval.list) = d3dcompiler_alloc(sizeof(*(yyval.list)));
                                list_init((yyval.list));
                                list_add_head((yyval.list), &(yyvsp[(1) - (1)].variable_def)->entry);
                            ;}
    break;

  case 56:

/* Line 1464 of yacc.c  */
#line 1460 "hlsl.y"
    {
                                (yyval.list) = (yyvsp[(1) - (3)].list);
                                list_add_tail((yyval.list), &(yyvsp[(3) - (3)].variable_def)->entry);
                            ;}
    break;

  case 57:

/* Line 1464 of yacc.c  */
#line 1466 "hlsl.y"
    {
                                (yyval.variable_def) = d3dcompiler_alloc(sizeof(*(yyval.variable_def)));
                                set_location(&(yyval.variable_def)->loc, &(yylsp[(1) - (2)]));
                                (yyval.variable_def)->name = (yyvsp[(1) - (2)].name);
                                (yyval.variable_def)->array_size = (yyvsp[(2) - (2)].intval);
                            ;}
    break;

  case 58:

/* Line 1464 of yacc.c  */
#line 1474 "hlsl.y"
    {
                                (yyval.list) = declare_vars((yyvsp[(2) - (4)].type), (yyvsp[(1) - (4)].modifiers), (yyvsp[(3) - (4)].list));
                            ;}
    break;

  case 59:

/* Line 1464 of yacc.c  */
#line 1479 "hlsl.y"
    {
                                (yyval.list) = NULL;
                            ;}
    break;

  case 60:

/* Line 1464 of yacc.c  */
#line 1483 "hlsl.y"
    {
                                (yyval.list) = (yyvsp[(1) - (1)].list);
                            ;}
    break;

  case 61:

/* Line 1464 of yacc.c  */
#line 1488 "hlsl.y"
    {
                                (yyval.list) = d3dcompiler_alloc(sizeof(*(yyval.list)));
                                list_init((yyval.list));
                                list_add_head((yyval.list), &(yyvsp[(1) - (1)].variable_def)->entry);
                            ;}
    break;

  case 62:

/* Line 1464 of yacc.c  */
#line 1494 "hlsl.y"
    {
                                (yyval.list) = (yyvsp[(1) - (3)].list);
                                list_add_tail((yyval.list), &(yyvsp[(3) - (3)].variable_def)->entry);
                            ;}
    break;

  case 63:

/* Line 1464 of yacc.c  */
#line 1500 "hlsl.y"
    {
                                (yyval.variable_def) = d3dcompiler_alloc(sizeof(*(yyval.variable_def)));
                                set_location(&(yyval.variable_def)->loc, &(yylsp[(1) - (3)]));
                                (yyval.variable_def)->name = (yyvsp[(1) - (3)].name);
                                (yyval.variable_def)->array_size = (yyvsp[(2) - (3)].intval);
                                (yyval.variable_def)->semantic = (yyvsp[(3) - (3)].name);
                            ;}
    break;

  case 64:

/* Line 1464 of yacc.c  */
#line 1508 "hlsl.y"
    {
                                TRACE("Declaration with initializer.\n");
                                (yyval.variable_def) = d3dcompiler_alloc(sizeof(*(yyval.variable_def)));
                                set_location(&(yyval.variable_def)->loc, &(yylsp[(1) - (5)]));
                                (yyval.variable_def)->name = (yyvsp[(1) - (5)].name);
                                (yyval.variable_def)->array_size = (yyvsp[(2) - (5)].intval);
                                (yyval.variable_def)->semantic = (yyvsp[(3) - (5)].name);
                                (yyval.variable_def)->initializer = (yyvsp[(5) - (5)].list);
                            ;}
    break;

  case 65:

/* Line 1464 of yacc.c  */
#line 1519 "hlsl.y"
    {
                                (yyval.intval) = 0;
                            ;}
    break;

  case 66:

/* Line 1464 of yacc.c  */
#line 1523 "hlsl.y"
    {
                                FIXME("Array.\n");
                                (yyval.intval) = 0;
                                free_instr((yyvsp[(2) - (3)].instr));
                            ;}
    break;

  case 67:

/* Line 1464 of yacc.c  */
#line 1530 "hlsl.y"
    {
                                (yyval.modifiers) = 0;
                            ;}
    break;

  case 68:

/* Line 1464 of yacc.c  */
#line 1534 "hlsl.y"
    {
                                (yyval.modifiers) = add_modifier((yyvsp[(2) - (2)].modifiers), HLSL_STORAGE_EXTERN, &(yylsp[(1) - (2)]));
                            ;}
    break;

  case 69:

/* Line 1464 of yacc.c  */
#line 1538 "hlsl.y"
    {
                                (yyval.modifiers) = add_modifier((yyvsp[(2) - (2)].modifiers), HLSL_STORAGE_NOINTERPOLATION, &(yylsp[(1) - (2)]));
                            ;}
    break;

  case 70:

/* Line 1464 of yacc.c  */
#line 1542 "hlsl.y"
    {
                                (yyval.modifiers) = add_modifier((yyvsp[(2) - (2)].modifiers), HLSL_MODIFIER_PRECISE, &(yylsp[(1) - (2)]));
                            ;}
    break;

  case 71:

/* Line 1464 of yacc.c  */
#line 1546 "hlsl.y"
    {
                                (yyval.modifiers) = add_modifier((yyvsp[(2) - (2)].modifiers), HLSL_STORAGE_SHARED, &(yylsp[(1) - (2)]));
                            ;}
    break;

  case 72:

/* Line 1464 of yacc.c  */
#line 1550 "hlsl.y"
    {
                                (yyval.modifiers) = add_modifier((yyvsp[(2) - (2)].modifiers), HLSL_STORAGE_GROUPSHARED, &(yylsp[(1) - (2)]));
                            ;}
    break;

  case 73:

/* Line 1464 of yacc.c  */
#line 1554 "hlsl.y"
    {
                                (yyval.modifiers) = add_modifier((yyvsp[(2) - (2)].modifiers), HLSL_STORAGE_STATIC, &(yylsp[(1) - (2)]));
                            ;}
    break;

  case 74:

/* Line 1464 of yacc.c  */
#line 1558 "hlsl.y"
    {
                                (yyval.modifiers) = add_modifier((yyvsp[(2) - (2)].modifiers), HLSL_STORAGE_UNIFORM, &(yylsp[(1) - (2)]));
                            ;}
    break;

  case 75:

/* Line 1464 of yacc.c  */
#line 1562 "hlsl.y"
    {
                                (yyval.modifiers) = add_modifier((yyvsp[(2) - (2)].modifiers), HLSL_STORAGE_VOLATILE, &(yylsp[(1) - (2)]));
                            ;}
    break;

  case 76:

/* Line 1464 of yacc.c  */
#line 1566 "hlsl.y"
    {
                                (yyval.modifiers) = add_modifier((yyvsp[(2) - (2)].modifiers), HLSL_MODIFIER_CONST, &(yylsp[(1) - (2)]));
                            ;}
    break;

  case 77:

/* Line 1464 of yacc.c  */
#line 1570 "hlsl.y"
    {
                                (yyval.modifiers) = add_modifier((yyvsp[(2) - (2)].modifiers), HLSL_MODIFIER_ROW_MAJOR, &(yylsp[(1) - (2)]));
                            ;}
    break;

  case 78:

/* Line 1464 of yacc.c  */
#line 1574 "hlsl.y"
    {
                                (yyval.modifiers) = add_modifier((yyvsp[(2) - (2)].modifiers), HLSL_MODIFIER_COLUMN_MAJOR, &(yylsp[(1) - (2)]));
                            ;}
    break;

  case 79:

/* Line 1464 of yacc.c  */
#line 1579 "hlsl.y"
    {
                                (yyval.list) = d3dcompiler_alloc(sizeof(*(yyval.list)));
                                list_init((yyval.list));
                                list_add_head((yyval.list), &(yyvsp[(1) - (1)].instr)->entry);
                            ;}
    break;

  case 80:

/* Line 1464 of yacc.c  */
#line 1585 "hlsl.y"
    {
                                (yyval.list) = (yyvsp[(2) - (3)].list);
                            ;}
    break;

  case 81:

/* Line 1464 of yacc.c  */
#line 1590 "hlsl.y"
    {
                                (yyval.instr) = (yyvsp[(1) - (1)].instr);
                            ;}
    break;

  case 82:

/* Line 1464 of yacc.c  */
#line 1595 "hlsl.y"
    {
                                (yyval.list) = d3dcompiler_alloc(sizeof(*(yyval.list)));
                                list_init((yyval.list));
                                list_add_head((yyval.list), &(yyvsp[(1) - (1)].instr)->entry);
                            ;}
    break;

  case 83:

/* Line 1464 of yacc.c  */
#line 1601 "hlsl.y"
    {
                                (yyval.list) = (yyvsp[(1) - (3)].list);
                                list_add_tail((yyval.list), &(yyvsp[(3) - (3)].instr)->entry);
                            ;}
    break;

  case 84:

/* Line 1464 of yacc.c  */
#line 1607 "hlsl.y"
    {
                                (yyval.boolval) = TRUE;
                            ;}
    break;

  case 85:

/* Line 1464 of yacc.c  */
#line 1611 "hlsl.y"
    {
                                (yyval.boolval) = FALSE;
                            ;}
    break;

  case 86:

/* Line 1464 of yacc.c  */
#line 1616 "hlsl.y"
    {
                                (yyval.list) = (yyvsp[(1) - (1)].list);
                            ;}
    break;

  case 87:

/* Line 1464 of yacc.c  */
#line 1620 "hlsl.y"
    {
                                (yyval.list) = (yyvsp[(1) - (2)].list);
                                list_move_tail((yyval.list), (yyvsp[(2) - (2)].list));
                                d3dcompiler_free((yyvsp[(2) - (2)].list));
                            ;}
    break;

  case 94:

/* Line 1464 of yacc.c  */
#line 1635 "hlsl.y"
    {
                                struct hlsl_ir_jump *jump = d3dcompiler_alloc(sizeof(*jump));
                                if (!jump)
                                {
                                    ERR("Out of memory\n");
                                    return -1;
                                }
                                jump->node.type = HLSL_IR_JUMP;
                                set_location(&jump->node.loc, &(yylsp[(1) - (3)]));
                                jump->type = HLSL_IR_JUMP_RETURN;
                                jump->node.data_type = (yyvsp[(2) - (3)].instr)->data_type;
                                jump->return_value = (yyvsp[(2) - (3)].instr);

                                FIXME("Check for valued return on void function.\n");
                                FIXME("Implicit conversion to the return type if needed, "
				        "error out if conversion not possible.\n");

                                (yyval.list) = d3dcompiler_alloc(sizeof(*(yyval.list)));
                                list_init((yyval.list));
                                list_add_tail((yyval.list), &jump->node.entry);
                            ;}
    break;

  case 95:

/* Line 1464 of yacc.c  */
#line 1658 "hlsl.y"
    {
                                struct hlsl_ir_if *instr = d3dcompiler_alloc(sizeof(*instr));
                                if (!instr)
                                {
                                    ERR("Out of memory\n");
                                    return -1;
                                }
                                instr->node.type = HLSL_IR_IF;
                                set_location(&instr->node.loc, &(yylsp[(1) - (5)]));
                                instr->condition = (yyvsp[(3) - (5)].instr);
                                instr->then_instrs = (yyvsp[(5) - (5)].if_body).then_instrs;
                                instr->else_instrs = (yyvsp[(5) - (5)].if_body).else_instrs;
                                if ((yyvsp[(3) - (5)].instr)->data_type->dimx > 1 || (yyvsp[(3) - (5)].instr)->data_type->dimy > 1)
                                {
                                    hlsl_report_message(instr->node.loc.file, instr->node.loc.line,
                                            instr->node.loc.col, HLSL_LEVEL_ERROR,
                                            "if condition requires a scalar");
                                }
                                (yyval.list) = d3dcompiler_alloc(sizeof(*(yyval.list)));
                                list_init((yyval.list));
                                list_add_head((yyval.list), &instr->node.entry);
                            ;}
    break;

  case 96:

/* Line 1464 of yacc.c  */
#line 1682 "hlsl.y"
    {
                                (yyval.if_body).then_instrs = (yyvsp[(1) - (1)].list);
                                (yyval.if_body).else_instrs = NULL;
                            ;}
    break;

  case 97:

/* Line 1464 of yacc.c  */
#line 1687 "hlsl.y"
    {
                                (yyval.if_body).then_instrs = (yyvsp[(1) - (3)].list);
                                (yyval.if_body).else_instrs = (yyvsp[(3) - (3)].list);
                            ;}
    break;

  case 98:

/* Line 1464 of yacc.c  */
#line 1693 "hlsl.y"
    {
                                struct source_location loc;
                                struct list *cond = d3dcompiler_alloc(sizeof(*cond));

                                if (!cond)
                                {
                                    ERR("Out of memory.\n");
                                    return -1;
                                }
                                list_init(cond);
                                list_add_head(cond, &(yyvsp[(3) - (5)].instr)->entry);
                                set_location(&loc, &(yylsp[(1) - (5)]));
                                (yyval.list) = create_loop(LOOP_WHILE, NULL, cond, NULL, (yyvsp[(5) - (5)].list), &loc);
                            ;}
    break;

  case 99:

/* Line 1464 of yacc.c  */
#line 1708 "hlsl.y"
    {
                                struct source_location loc;
                                struct list *cond = d3dcompiler_alloc(sizeof(*cond));

                                if (!cond)
                                {
                                    ERR("Out of memory.\n");
                                    return -1;
                                }
                                list_init(cond);
                                list_add_head(cond, &(yyvsp[(5) - (7)].instr)->entry);
                                set_location(&loc, &(yylsp[(1) - (7)]));
                                (yyval.list) = create_loop(LOOP_DO_WHILE, NULL, cond, NULL, (yyvsp[(2) - (7)].list), &loc);
                            ;}
    break;

  case 100:

/* Line 1464 of yacc.c  */
#line 1723 "hlsl.y"
    {
                                struct source_location loc;

                                set_location(&loc, &(yylsp[(1) - (8)]));
                                (yyval.list) = create_loop(LOOP_FOR, (yyvsp[(4) - (8)].list), (yyvsp[(5) - (8)].list), (yyvsp[(6) - (8)].instr), (yyvsp[(8) - (8)].list), &loc);
                                pop_scope(&hlsl_ctx);
                            ;}
    break;

  case 101:

/* Line 1464 of yacc.c  */
#line 1731 "hlsl.y"
    {
                                struct source_location loc;

                                set_location(&loc, &(yylsp[(1) - (8)]));
                                if (!(yyvsp[(4) - (8)].list))
                                    hlsl_report_message(loc.file, loc.line, loc.col, HLSL_LEVEL_WARNING,
                                            "no expressions in for loop initializer");
                                (yyval.list) = create_loop(LOOP_FOR, (yyvsp[(4) - (8)].list), (yyvsp[(5) - (8)].list), (yyvsp[(6) - (8)].instr), (yyvsp[(8) - (8)].list), &loc);
                                pop_scope(&hlsl_ctx);
                            ;}
    break;

  case 102:

/* Line 1464 of yacc.c  */
#line 1743 "hlsl.y"
    {
                                (yyval.list) = d3dcompiler_alloc(sizeof(*(yyval.list)));
                                list_init((yyval.list));
                            ;}
    break;

  case 103:

/* Line 1464 of yacc.c  */
#line 1748 "hlsl.y"
    {
                                (yyval.list) = d3dcompiler_alloc(sizeof(*(yyval.list)));
                                list_init((yyval.list));
                                if ((yyvsp[(1) - (2)].instr))
                                    list_add_head((yyval.list), &(yyvsp[(1) - (2)].instr)->entry);
                            ;}
    break;

  case 104:

/* Line 1464 of yacc.c  */
#line 1756 "hlsl.y"
    {
                                struct hlsl_ir_constant *c = d3dcompiler_alloc(sizeof(*c));
                                if (!c)
                                {
                                    ERR("Out of memory.\n");
                                    return -1;
                                }
                                c->node.type = HLSL_IR_CONSTANT;
                                set_location(&c->node.loc, &yylloc);
                                c->node.data_type = new_hlsl_type("float", HLSL_CLASS_SCALAR, HLSL_TYPE_FLOAT, 1, 1);
                                c->v.value.f[0] = (yyvsp[(1) - (1)].floatval);
                                (yyval.instr) = &c->node;
                            ;}
    break;

  case 105:

/* Line 1464 of yacc.c  */
#line 1770 "hlsl.y"
    {
                                struct hlsl_ir_constant *c = d3dcompiler_alloc(sizeof(*c));
                                if (!c)
                                {
                                    ERR("Out of memory.\n");
                                    return -1;
                                }
                                c->node.type = HLSL_IR_CONSTANT;
                                set_location(&c->node.loc, &yylloc);
                                c->node.data_type = new_hlsl_type("int", HLSL_CLASS_SCALAR, HLSL_TYPE_INT, 1, 1);
                                c->v.value.i[0] = (yyvsp[(1) - (1)].intval);
                                (yyval.instr) = &c->node;
                            ;}
    break;

  case 106:

/* Line 1464 of yacc.c  */
#line 1784 "hlsl.y"
    {
                                struct hlsl_ir_constant *c = d3dcompiler_alloc(sizeof(*c));
                                if (!c)
                                {
                                    ERR("Out of memory.\n");
                                    return -1;
                                }
                                c->node.type = HLSL_IR_CONSTANT;
                                set_location(&c->node.loc, &yylloc);
                                c->node.data_type = new_hlsl_type("bool", HLSL_CLASS_SCALAR, HLSL_TYPE_BOOL, 1, 1);
                                c->v.value.b[0] = (yyvsp[(1) - (1)].boolval);
                                (yyval.instr) = &c->node;
                            ;}
    break;

  case 107:

/* Line 1464 of yacc.c  */
#line 1798 "hlsl.y"
    {
                                struct hlsl_ir_deref *deref = new_var_deref((yyvsp[(1) - (1)].var));
                                if (deref)
                                {
                                    (yyval.instr) = &deref->node;
                                    set_location(&(yyval.instr)->loc, &(yylsp[(1) - (1)]));
                                }
                                else
                                    (yyval.instr) = NULL;
                            ;}
    break;

  case 108:

/* Line 1464 of yacc.c  */
#line 1809 "hlsl.y"
    {
                                (yyval.instr) = (yyvsp[(2) - (3)].instr);
                            ;}
    break;

  case 109:

/* Line 1464 of yacc.c  */
#line 1814 "hlsl.y"
    {
                                struct hlsl_ir_var *var;
                                var = get_variable(hlsl_ctx.cur_scope, (yyvsp[(1) - (1)].name));
                                if (!var)
                                {
                                    hlsl_message("Line %d: variable '%s' not declared\n",
                                            hlsl_ctx.line_no, (yyvsp[(1) - (1)].name));
                                    set_parse_status(&hlsl_ctx.status, PARSE_ERR);
                                    return 1;
                                }
                                (yyval.var) = var;
                            ;}
    break;

  case 110:

/* Line 1464 of yacc.c  */
#line 1828 "hlsl.y"
    {
                                (yyval.instr) = (yyvsp[(1) - (1)].instr);
                            ;}
    break;

  case 111:

/* Line 1464 of yacc.c  */
#line 1832 "hlsl.y"
    {
                                struct hlsl_ir_node *operands[3];
                                struct source_location loc;

                                set_location(&loc, &(yylsp[(2) - (2)]));
                                if ((yyvsp[(1) - (2)].instr)->data_type->modifiers & HLSL_MODIFIER_CONST)
                                {
                                    hlsl_report_message(loc.file, loc.line, loc.col, HLSL_LEVEL_ERROR,
                                            "modifying a const expression");
                                    return 1;
                                }
                                operands[0] = (yyvsp[(1) - (2)].instr);
                                operands[1] = operands[2] = NULL;
                                (yyval.instr) = &new_expr(HLSL_IR_BINOP_POSTINC, operands, &loc)->node;
                                /* Post increment/decrement expressions are considered const */
                                (yyval.instr)->data_type = clone_hlsl_type((yyval.instr)->data_type);
                                (yyval.instr)->data_type->modifiers |= HLSL_MODIFIER_CONST;
                            ;}
    break;

  case 112:

/* Line 1464 of yacc.c  */
#line 1851 "hlsl.y"
    {
                                struct hlsl_ir_node *operands[3];
                                struct source_location loc;

                                set_location(&loc, &(yylsp[(2) - (2)]));
                                if ((yyvsp[(1) - (2)].instr)->data_type->modifiers & HLSL_MODIFIER_CONST)
                                {
                                    hlsl_report_message(loc.file, loc.line, loc.col, HLSL_LEVEL_ERROR,
                                            "modifying a const expression");
                                    return 1;
                                }
                                operands[0] = (yyvsp[(1) - (2)].instr);
                                operands[1] = operands[2] = NULL;
                                (yyval.instr) = &new_expr(HLSL_IR_BINOP_POSTDEC, operands, &loc)->node;
                                /* Post increment/decrement expressions are considered const */
                                (yyval.instr)->data_type = clone_hlsl_type((yyval.instr)->data_type);
                                (yyval.instr)->data_type->modifiers |= HLSL_MODIFIER_CONST;
                            ;}
    break;

  case 113:

/* Line 1464 of yacc.c  */
#line 1870 "hlsl.y"
    {
                                struct source_location loc;

                                set_location(&loc, &(yylsp[(2) - (3)]));
                                if ((yyvsp[(1) - (3)].instr)->data_type->type == HLSL_CLASS_STRUCT)
                                {
                                    struct hlsl_type *type = (yyvsp[(1) - (3)].instr)->data_type;
                                    struct hlsl_struct_field *field;

                                    (yyval.instr) = NULL;
                                    LIST_FOR_EACH_ENTRY(field, type->e.elements, struct hlsl_struct_field, entry)
                                    {
                                        if (!strcmp((yyvsp[(3) - (3)].name), field->name))
                                        {
                                            struct hlsl_ir_deref *deref = new_record_deref((yyvsp[(1) - (3)].instr), field);

                                            if (!deref)
                                            {
                                                ERR("Out of memory\n");
                                                return -1;
                                            }
                                            deref->node.loc = loc;
                                            (yyval.instr) = &deref->node;
                                            break;
                                        }
                                    }
                                    if (!(yyval.instr))
                                    {
                                        hlsl_report_message(loc.file, loc.line, loc.col, HLSL_LEVEL_ERROR,
                                                "invalid subscript %s", debugstr_a((yyvsp[(3) - (3)].name)));
                                        return 1;
                                    }
                                }
                                else if ((yyvsp[(1) - (3)].instr)->data_type->type <= HLSL_CLASS_LAST_NUMERIC)
                                {
                                    struct hlsl_ir_swizzle *swizzle;

                                    swizzle = get_swizzle((yyvsp[(1) - (3)].instr), (yyvsp[(3) - (3)].name), &loc);
                                    if (!swizzle)
                                    {
                                        hlsl_report_message(loc.file, loc.line, loc.col, HLSL_LEVEL_ERROR,
                                                "invalid swizzle %s", debugstr_a((yyvsp[(3) - (3)].name)));
                                        return 1;
                                    }
                                    (yyval.instr) = &swizzle->node;
                                }
                                else
                                {
                                    hlsl_report_message(loc.file, loc.line, loc.col, HLSL_LEVEL_ERROR,
                                            "invalid subscript %s", debugstr_a((yyvsp[(3) - (3)].name)));
                                    return 1;
                                }
                            ;}
    break;

  case 114:

/* Line 1464 of yacc.c  */
#line 1924 "hlsl.y"
    {
                                /* This may be an array dereference or a vector/matrix
                                 * subcomponent access.
                                 * We store it as an array dereference in any case. */
                                struct hlsl_ir_deref *deref = d3dcompiler_alloc(sizeof(*deref));
                                struct hlsl_type *expr_type = (yyvsp[(1) - (4)].instr)->data_type;
                                struct source_location loc;

                                TRACE("Array dereference from type %s\n", debug_hlsl_type(expr_type));
                                if (!deref)
                                {
                                    ERR("Out of memory\n");
                                    return -1;
                                }
                                deref->node.type = HLSL_IR_DEREF;
                                set_location(&loc, &(yylsp[(2) - (4)]));
                                deref->node.loc = loc;
                                if (expr_type->type == HLSL_CLASS_ARRAY)
                                {
                                    deref->node.data_type = expr_type->e.array.type;
                                }
                                else if (expr_type->type == HLSL_CLASS_MATRIX)
                                {
                                    deref->node.data_type = new_hlsl_type(NULL, HLSL_CLASS_VECTOR, expr_type->base_type, expr_type->dimx, 1);
                                }
                                else if (expr_type->type == HLSL_CLASS_VECTOR)
                                {
                                    deref->node.data_type = new_hlsl_type(NULL, HLSL_CLASS_SCALAR, expr_type->base_type, 1, 1);
                                }
                                else
                                {
                                    if (expr_type->type == HLSL_CLASS_SCALAR)
                                        hlsl_report_message(loc.file, loc.line, loc.col, HLSL_LEVEL_ERROR,
                                                "array-indexed expression is scalar");
                                    else
                                        hlsl_report_message(loc.file, loc.line, loc.col, HLSL_LEVEL_ERROR,
                                                "expression is not array-indexable");
                                    d3dcompiler_free(deref);
                                    free_instr((yyvsp[(1) - (4)].instr));
                                    free_instr((yyvsp[(3) - (4)].instr));
                                    return 1;
                                }
                                if ((yyvsp[(3) - (4)].instr)->data_type->type != HLSL_CLASS_SCALAR)
                                {
                                    hlsl_report_message(loc.file, loc.line, loc.col, HLSL_LEVEL_ERROR,
                                            "array index is not scalar");
                                    d3dcompiler_free(deref);
                                    free_instr((yyvsp[(1) - (4)].instr));
                                    free_instr((yyvsp[(3) - (4)].instr));
                                    return 1;
                                }
                                deref->type = HLSL_IR_DEREF_ARRAY;
                                deref->v.array.array = (yyvsp[(1) - (4)].instr);
                                deref->v.array.index = (yyvsp[(3) - (4)].instr);

                                (yyval.instr) = &deref->node;
                            ;}
    break;

  case 115:

/* Line 1464 of yacc.c  */
#line 1984 "hlsl.y"
    {
                                struct hlsl_ir_constructor *constructor;

                                TRACE("%s constructor.\n", debug_hlsl_type((yyvsp[(2) - (5)].type)));
                                if ((yyvsp[(1) - (5)].modifiers))
                                {
                                    hlsl_message("Line %u: unexpected modifier in a constructor.\n",
                                            hlsl_ctx.line_no);
                                    set_parse_status(&hlsl_ctx.status, PARSE_ERR);
                                    return -1;
                                }
                                if ((yyvsp[(2) - (5)].type)->type > HLSL_CLASS_LAST_NUMERIC)
                                {
                                    hlsl_message("Line %u: constructors are allowed only for numeric data types.\n",
                                            hlsl_ctx.line_no);
                                    set_parse_status(&hlsl_ctx.status, PARSE_ERR);
                                    return -1;
                                }
                                if ((yyvsp[(2) - (5)].type)->dimx * (yyvsp[(2) - (5)].type)->dimy != components_count_expr_list((yyvsp[(4) - (5)].list)))
                                {
                                    hlsl_message("Line %u: wrong number of components in constructor.\n",
                                            hlsl_ctx.line_no);
                                    set_parse_status(&hlsl_ctx.status, PARSE_ERR);
                                    return -1;
                                }

                                constructor = d3dcompiler_alloc(sizeof(*constructor));
                                constructor->node.type = HLSL_IR_CONSTRUCTOR;
                                set_location(&constructor->node.loc, &(yylsp[(3) - (5)]));
                                constructor->node.data_type = (yyvsp[(2) - (5)].type);
                                constructor->arguments = (yyvsp[(4) - (5)].list);

                                (yyval.instr) = &constructor->node;
                            ;}
    break;

  case 116:

/* Line 1464 of yacc.c  */
#line 2020 "hlsl.y"
    {
                                (yyval.instr) = (yyvsp[(1) - (1)].instr);
                            ;}
    break;

  case 117:

/* Line 1464 of yacc.c  */
#line 2024 "hlsl.y"
    {
                                struct hlsl_ir_node *operands[3];
                                struct source_location loc;

                                set_location(&loc, &(yylsp[(1) - (2)]));
                                if ((yyvsp[(2) - (2)].instr)->data_type->modifiers & HLSL_MODIFIER_CONST)
                                {
                                    hlsl_report_message(loc.file, loc.line, loc.col, HLSL_LEVEL_ERROR,
                                            "modifying a const expression");
                                    return 1;
                                }
                                operands[0] = (yyvsp[(2) - (2)].instr);
                                operands[1] = operands[2] = NULL;
                                (yyval.instr) = &new_expr(HLSL_IR_BINOP_PREINC, operands, &loc)->node;
                            ;}
    break;

  case 118:

/* Line 1464 of yacc.c  */
#line 2040 "hlsl.y"
    {
                                struct hlsl_ir_node *operands[3];
                                struct source_location loc;

                                set_location(&loc, &(yylsp[(1) - (2)]));
                                if ((yyvsp[(2) - (2)].instr)->data_type->modifiers & HLSL_MODIFIER_CONST)
                                {
                                    hlsl_report_message(loc.file, loc.line, loc.col, HLSL_LEVEL_ERROR,
                                            "modifying a const expression");
                                    return 1;
                                }
                                operands[0] = (yyvsp[(2) - (2)].instr);
                                operands[1] = operands[2] = NULL;
                                (yyval.instr) = &new_expr(HLSL_IR_BINOP_PREDEC, operands, &loc)->node;
                            ;}
    break;

  case 119:

/* Line 1464 of yacc.c  */
#line 2056 "hlsl.y"
    {
                                enum hlsl_ir_expr_op ops[] = {0, HLSL_IR_UNOP_NEG,
                                        HLSL_IR_UNOP_LOGIC_NOT, HLSL_IR_UNOP_BIT_NOT};
                                struct hlsl_ir_node *operands[3];
                                struct source_location loc;

                                if ((yyvsp[(1) - (2)].unary_op) == UNARY_OP_PLUS)
                                {
                                    (yyval.instr) = (yyvsp[(2) - (2)].instr);
                                }
                                else
                                {
                                    operands[0] = (yyvsp[(2) - (2)].instr);
                                    operands[1] = operands[2] = NULL;
                                    set_location(&loc, &(yylsp[(1) - (2)]));
                                    (yyval.instr) = &new_expr(ops[(yyvsp[(1) - (2)].unary_op)], operands, &loc)->node;
                                }
                            ;}
    break;

  case 120:

/* Line 1464 of yacc.c  */
#line 2076 "hlsl.y"
    {
                                struct hlsl_ir_expr *expr;
                                struct hlsl_type *src_type = (yyvsp[(6) - (6)].instr)->data_type;
                                struct hlsl_type *dst_type;
                                struct source_location loc;

                                set_location(&loc, &(yylsp[(3) - (6)]));
                                if ((yyvsp[(2) - (6)].modifiers))
                                {
                                    hlsl_report_message(loc.file, loc.line, loc.col, HLSL_LEVEL_ERROR,
                                            "unexpected modifier in a cast");
                                    return 1;
                                }

                                if ((yyvsp[(4) - (6)].intval))
                                    dst_type = new_array_type((yyvsp[(3) - (6)].type), (yyvsp[(4) - (6)].intval));
                                else
                                    dst_type = (yyvsp[(3) - (6)].type);

                                if (!compatible_data_types(src_type, dst_type))
                                {
                                    hlsl_report_message(loc.file, loc.line, loc.col, HLSL_LEVEL_ERROR,
                                            "can't cast from %s to %s",
                                            debug_hlsl_type(src_type), debug_hlsl_type(dst_type));
                                    return 1;
                                }

                                expr = new_cast((yyvsp[(6) - (6)].instr), dst_type, &loc);
                                (yyval.instr) = expr ? &expr->node : NULL;
                            ;}
    break;

  case 121:

/* Line 1464 of yacc.c  */
#line 2108 "hlsl.y"
    {
                                (yyval.unary_op) = UNARY_OP_PLUS;
                            ;}
    break;

  case 122:

/* Line 1464 of yacc.c  */
#line 2112 "hlsl.y"
    {
                                (yyval.unary_op) = UNARY_OP_MINUS;
                            ;}
    break;

  case 123:

/* Line 1464 of yacc.c  */
#line 2116 "hlsl.y"
    {
                                (yyval.unary_op) = UNARY_OP_LOGICNOT;
                            ;}
    break;

  case 124:

/* Line 1464 of yacc.c  */
#line 2120 "hlsl.y"
    {
                                (yyval.unary_op) = UNARY_OP_BITNOT;
                            ;}
    break;

  case 125:

/* Line 1464 of yacc.c  */
#line 2125 "hlsl.y"
    {
                                (yyval.instr) = (yyvsp[(1) - (1)].instr);
                            ;}
    break;

  case 126:

/* Line 1464 of yacc.c  */
#line 2129 "hlsl.y"
    {
                                struct source_location loc;

                                set_location(&loc, &(yylsp[(2) - (3)]));
                                (yyval.instr) = &hlsl_mul((yyvsp[(1) - (3)].instr), (yyvsp[(3) - (3)].instr), &loc)->node;
                            ;}
    break;

  case 127:

/* Line 1464 of yacc.c  */
#line 2136 "hlsl.y"
    {
                                struct source_location loc;

                                set_location(&loc, &(yylsp[(2) - (3)]));
                                (yyval.instr) = &hlsl_div((yyvsp[(1) - (3)].instr), (yyvsp[(3) - (3)].instr), &loc)->node;
                            ;}
    break;

  case 128:

/* Line 1464 of yacc.c  */
#line 2143 "hlsl.y"
    {
                                struct source_location loc;

                                set_location(&loc, &(yylsp[(2) - (3)]));
                                (yyval.instr) = &hlsl_mod((yyvsp[(1) - (3)].instr), (yyvsp[(3) - (3)].instr), &loc)->node;
                            ;}
    break;

  case 129:

/* Line 1464 of yacc.c  */
#line 2151 "hlsl.y"
    {
                                (yyval.instr) = (yyvsp[(1) - (1)].instr);
                            ;}
    break;

  case 130:

/* Line 1464 of yacc.c  */
#line 2155 "hlsl.y"
    {
                                struct source_location loc;

                                set_location(&loc, &(yylsp[(2) - (3)]));
                                (yyval.instr) = &hlsl_add((yyvsp[(1) - (3)].instr), (yyvsp[(3) - (3)].instr), &loc)->node;
                            ;}
    break;

  case 131:

/* Line 1464 of yacc.c  */
#line 2162 "hlsl.y"
    {
                                struct source_location loc;

                                set_location(&loc, &(yylsp[(2) - (3)]));
                                (yyval.instr) = &hlsl_sub((yyvsp[(1) - (3)].instr), (yyvsp[(3) - (3)].instr), &loc)->node;
                            ;}
    break;

  case 132:

/* Line 1464 of yacc.c  */
#line 2170 "hlsl.y"
    {
                                (yyval.instr) = (yyvsp[(1) - (1)].instr);
                            ;}
    break;

  case 133:

/* Line 1464 of yacc.c  */
#line 2174 "hlsl.y"
    {
                                FIXME("Left shift\n");
                            ;}
    break;

  case 134:

/* Line 1464 of yacc.c  */
#line 2178 "hlsl.y"
    {
                                FIXME("Right shift\n");
                            ;}
    break;

  case 135:

/* Line 1464 of yacc.c  */
#line 2183 "hlsl.y"
    {
                                (yyval.instr) = (yyvsp[(1) - (1)].instr);
                            ;}
    break;

  case 136:

/* Line 1464 of yacc.c  */
#line 2187 "hlsl.y"
    {
                                struct source_location loc;

                                set_location(&loc, &(yylsp[(2) - (3)]));
                                (yyval.instr) = &hlsl_lt((yyvsp[(1) - (3)].instr), (yyvsp[(3) - (3)].instr), &loc)->node;
                            ;}
    break;

  case 137:

/* Line 1464 of yacc.c  */
#line 2194 "hlsl.y"
    {
                                struct source_location loc;

                                set_location(&loc, &(yylsp[(2) - (3)]));
                                (yyval.instr) = &hlsl_gt((yyvsp[(1) - (3)].instr), (yyvsp[(3) - (3)].instr), &loc)->node;
                            ;}
    break;

  case 138:

/* Line 1464 of yacc.c  */
#line 2201 "hlsl.y"
    {
                                struct source_location loc;

                                set_location(&loc, &(yylsp[(2) - (3)]));
                                (yyval.instr) = &hlsl_le((yyvsp[(1) - (3)].instr), (yyvsp[(3) - (3)].instr), &loc)->node;
                            ;}
    break;

  case 139:

/* Line 1464 of yacc.c  */
#line 2208 "hlsl.y"
    {
                                struct source_location loc;

                                set_location(&loc, &(yylsp[(2) - (3)]));
                                (yyval.instr) = &hlsl_ge((yyvsp[(1) - (3)].instr), (yyvsp[(3) - (3)].instr), &loc)->node;
                            ;}
    break;

  case 140:

/* Line 1464 of yacc.c  */
#line 2216 "hlsl.y"
    {
                                (yyval.instr) = (yyvsp[(1) - (1)].instr);
                            ;}
    break;

  case 141:

/* Line 1464 of yacc.c  */
#line 2220 "hlsl.y"
    {
                                struct source_location loc;

                                set_location(&loc, &(yylsp[(2) - (3)]));
                                (yyval.instr) = &hlsl_eq((yyvsp[(1) - (3)].instr), (yyvsp[(3) - (3)].instr), &loc)->node;
                            ;}
    break;

  case 142:

/* Line 1464 of yacc.c  */
#line 2227 "hlsl.y"
    {
                                struct source_location loc;

                                set_location(&loc, &(yylsp[(2) - (3)]));
                                (yyval.instr) = &hlsl_ne((yyvsp[(1) - (3)].instr), (yyvsp[(3) - (3)].instr), &loc)->node;
                            ;}
    break;

  case 143:

/* Line 1464 of yacc.c  */
#line 2235 "hlsl.y"
    {
                                (yyval.instr) = (yyvsp[(1) - (1)].instr);
                            ;}
    break;

  case 144:

/* Line 1464 of yacc.c  */
#line 2239 "hlsl.y"
    {
                                FIXME("bitwise AND\n");
                            ;}
    break;

  case 145:

/* Line 1464 of yacc.c  */
#line 2244 "hlsl.y"
    {
                                (yyval.instr) = (yyvsp[(1) - (1)].instr);
                            ;}
    break;

  case 146:

/* Line 1464 of yacc.c  */
#line 2248 "hlsl.y"
    {
                                FIXME("bitwise XOR\n");
                            ;}
    break;

  case 147:

/* Line 1464 of yacc.c  */
#line 2253 "hlsl.y"
    {
                                (yyval.instr) = (yyvsp[(1) - (1)].instr);
                            ;}
    break;

  case 148:

/* Line 1464 of yacc.c  */
#line 2257 "hlsl.y"
    {
                                FIXME("bitwise OR\n");
                            ;}
    break;

  case 149:

/* Line 1464 of yacc.c  */
#line 2262 "hlsl.y"
    {
                                (yyval.instr) = (yyvsp[(1) - (1)].instr);
                            ;}
    break;

  case 150:

/* Line 1464 of yacc.c  */
#line 2266 "hlsl.y"
    {
                                FIXME("logic AND\n");
                            ;}
    break;

  case 151:

/* Line 1464 of yacc.c  */
#line 2271 "hlsl.y"
    {
                                (yyval.instr) = (yyvsp[(1) - (1)].instr);
                            ;}
    break;

  case 152:

/* Line 1464 of yacc.c  */
#line 2275 "hlsl.y"
    {
                                FIXME("logic OR\n");
                            ;}
    break;

  case 153:

/* Line 1464 of yacc.c  */
#line 2280 "hlsl.y"
    {
                                (yyval.instr) = (yyvsp[(1) - (1)].instr);
                            ;}
    break;

  case 154:

/* Line 1464 of yacc.c  */
#line 2284 "hlsl.y"
    {
                                FIXME("ternary operator\n");
                            ;}
    break;

  case 155:

/* Line 1464 of yacc.c  */
#line 2289 "hlsl.y"
    {
                                (yyval.instr) = (yyvsp[(1) - (1)].instr);
                            ;}
    break;

  case 156:

/* Line 1464 of yacc.c  */
#line 2293 "hlsl.y"
    {
                                struct source_location loc;

                                set_location(&loc, &(yylsp[(2) - (3)]));
                                if ((yyvsp[(1) - (3)].instr)->data_type->modifiers & HLSL_MODIFIER_CONST)
                                {
                                    hlsl_report_message(loc.file, loc.line, loc.col, HLSL_LEVEL_ERROR,
                                            "l-value is const");
                                    return 1;
                                }
                                (yyval.instr) = make_assignment((yyvsp[(1) - (3)].instr), (yyvsp[(2) - (3)].assign_op), BWRITERSP_WRITEMASK_ALL, (yyvsp[(3) - (3)].instr));
                                if (!(yyval.instr))
                                    return 1;
                                (yyval.instr)->loc = loc;
                            ;}
    break;

  case 157:

/* Line 1464 of yacc.c  */
#line 2310 "hlsl.y"
    {
                                (yyval.assign_op) = ASSIGN_OP_ASSIGN;
                            ;}
    break;

  case 158:

/* Line 1464 of yacc.c  */
#line 2314 "hlsl.y"
    {
                                (yyval.assign_op) = ASSIGN_OP_ADD;
                            ;}
    break;

  case 159:

/* Line 1464 of yacc.c  */
#line 2318 "hlsl.y"
    {
                                (yyval.assign_op) = ASSIGN_OP_SUB;
                            ;}
    break;

  case 160:

/* Line 1464 of yacc.c  */
#line 2322 "hlsl.y"
    {
                                (yyval.assign_op) = ASSIGN_OP_MUL;
                            ;}
    break;

  case 161:

/* Line 1464 of yacc.c  */
#line 2326 "hlsl.y"
    {
                                (yyval.assign_op) = ASSIGN_OP_DIV;
                            ;}
    break;

  case 162:

/* Line 1464 of yacc.c  */
#line 2330 "hlsl.y"
    {
                                (yyval.assign_op) = ASSIGN_OP_MOD;
                            ;}
    break;

  case 163:

/* Line 1464 of yacc.c  */
#line 2334 "hlsl.y"
    {
                                (yyval.assign_op) = ASSIGN_OP_LSHIFT;
                            ;}
    break;

  case 164:

/* Line 1464 of yacc.c  */
#line 2338 "hlsl.y"
    {
                                (yyval.assign_op) = ASSIGN_OP_RSHIFT;
                            ;}
    break;

  case 165:

/* Line 1464 of yacc.c  */
#line 2342 "hlsl.y"
    {
                                (yyval.assign_op) = ASSIGN_OP_AND;
                            ;}
    break;

  case 166:

/* Line 1464 of yacc.c  */
#line 2346 "hlsl.y"
    {
                                (yyval.assign_op) = ASSIGN_OP_OR;
                            ;}
    break;

  case 167:

/* Line 1464 of yacc.c  */
#line 2350 "hlsl.y"
    {
                                (yyval.assign_op) = ASSIGN_OP_XOR;
                            ;}
    break;

  case 168:

/* Line 1464 of yacc.c  */
#line 2355 "hlsl.y"
    {
                                (yyval.instr) = (yyvsp[(1) - (1)].instr);
                            ;}
    break;

  case 169:

/* Line 1464 of yacc.c  */
#line 2359 "hlsl.y"
    {
                                FIXME("Comma expression\n");
                            ;}
    break;



/* Line 1464 of yacc.c  */
#line 4760 "hlsl.tab.c"
      default: break;
    }
  YY_SYMBOL_PRINT ("-> $$ =", yyr1[yyn], &yyval, &yyloc);

  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);

  *++yyvsp = yyval;
  *++yylsp = yyloc;

  /* Now `shift' the result of the reduction.  Determine what state
     that goes to, based on the state we popped back to and the rule
     number reduced by.  */

  yyn = yyr1[yyn];

  yystate = yypgoto[yyn - YYNTOKENS] + *yyssp;
  if (0 <= yystate && yystate <= YYLAST && yycheck[yystate] == *yyssp)
    yystate = yytable[yystate];
  else
    yystate = yydefgoto[yyn - YYNTOKENS];

  goto yynewstate;


/*------------------------------------.
| yyerrlab -- here on detecting error |
`------------------------------------*/
yyerrlab:
  /* If not already recovering from an error, report this error.  */
  if (!yyerrstatus)
    {
      ++yynerrs;
#if ! YYERROR_VERBOSE
      yyerror (YY_("syntax error"));
#else
      {
	YYSIZE_T yysize = yysyntax_error (0, yystate, yychar);
	if (yymsg_alloc < yysize && yymsg_alloc < YYSTACK_ALLOC_MAXIMUM)
	  {
	    YYSIZE_T yyalloc = 2 * yysize;
	    if (! (yysize <= yyalloc && yyalloc <= YYSTACK_ALLOC_MAXIMUM))
	      yyalloc = YYSTACK_ALLOC_MAXIMUM;
	    if (yymsg != yymsgbuf)
	      YYSTACK_FREE (yymsg);
	    yymsg = (char *) YYSTACK_ALLOC (yyalloc);
	    if (yymsg)
	      yymsg_alloc = yyalloc;
	    else
	      {
		yymsg = yymsgbuf;
		yymsg_alloc = sizeof yymsgbuf;
	      }
	  }

	if (0 < yysize && yysize <= yymsg_alloc)
	  {
	    (void) yysyntax_error (yymsg, yystate, yychar);
	    yyerror (yymsg);
	  }
	else
	  {
	    yyerror (YY_("syntax error"));
	    if (yysize != 0)
	      goto yyexhaustedlab;
	  }
      }
#endif
    }

  yyerror_range[0] = yylloc;

  if (yyerrstatus == 3)
    {
      /* If just tried and failed to reuse lookahead token after an
	 error, discard it.  */

      if (yychar <= YYEOF)
	{
	  /* Return failure if at end of input.  */
	  if (yychar == YYEOF)
	    YYABORT;
	}
      else
	{
	  yydestruct ("Error: discarding",
		      yytoken, &yylval, &yylloc);
	  yychar = YYEMPTY;
	}
    }

  /* Else will try to reuse lookahead token after shifting the error
     token.  */
  goto yyerrlab1;


/*---------------------------------------------------.
| yyerrorlab -- error raised explicitly by YYERROR.  |
`---------------------------------------------------*/
yyerrorlab:

  /* Pacify compilers like GCC when the user code never invokes
     YYERROR and the label yyerrorlab therefore never appears in user
     code.  */
  if (/*CONSTCOND*/ 0)
     goto yyerrorlab;

  yyerror_range[0] = yylsp[1-yylen];
  /* Do not reclaim the symbols of the rule which action triggered
     this YYERROR.  */
  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);
  yystate = *yyssp;
  goto yyerrlab1;


/*-------------------------------------------------------------.
| yyerrlab1 -- common code for both syntax error and YYERROR.  |
`-------------------------------------------------------------*/
yyerrlab1:
  yyerrstatus = 3;	/* Each real token shifted decrements this.  */

  for (;;)
    {
      yyn = yypact[yystate];
      if (yyn != YYPACT_NINF)
	{
	  yyn += YYTERROR;
	  if (0 <= yyn && yyn <= YYLAST && yycheck[yyn] == YYTERROR)
	    {
	      yyn = yytable[yyn];
	      if (0 < yyn)
		break;
	    }
	}

      /* Pop the current state because it cannot handle the error token.  */
      if (yyssp == yyss)
	YYABORT;

      yyerror_range[0] = *yylsp;
      yydestruct ("Error: popping",
		  yystos[yystate], yyvsp, yylsp);
      YYPOPSTACK (1);
      yystate = *yyssp;
      YY_STACK_PRINT (yyss, yyssp);
    }

  *++yyvsp = yylval;

  yyerror_range[1] = yylloc;
  /* Using YYLLOC is tempting, but would change the location of
     the lookahead.  YYLOC is available though.  */
  YYLLOC_DEFAULT (yyloc, (yyerror_range - 1), 2);
  *++yylsp = yyloc;

  /* Shift the error token.  */
  YY_SYMBOL_PRINT ("Shifting", yystos[yyn], yyvsp, yylsp);

  yystate = yyn;
  goto yynewstate;


/*-------------------------------------.
| yyacceptlab -- YYACCEPT comes here.  |
`-------------------------------------*/
yyacceptlab:
  yyresult = 0;
  goto yyreturn;

/*-----------------------------------.
| yyabortlab -- YYABORT comes here.  |
`-----------------------------------*/
yyabortlab:
  yyresult = 1;
  goto yyreturn;

#if !defined(yyoverflow) || YYERROR_VERBOSE
/*-------------------------------------------------.
| yyexhaustedlab -- memory exhaustion comes here.  |
`-------------------------------------------------*/
yyexhaustedlab:
  yyerror (YY_("memory exhausted"));
  yyresult = 2;
  /* Fall through.  */
#endif

yyreturn:
  if (yychar != YYEMPTY)
     yydestruct ("Cleanup: discarding lookahead",
		 yytoken, &yylval, &yylloc);
  /* Do not reclaim the symbols of the rule which action triggered
     this YYABORT or YYACCEPT.  */
  YYPOPSTACK (yylen);
  YY_STACK_PRINT (yyss, yyssp);
  while (yyssp != yyss)
    {
      yydestruct ("Cleanup: popping",
		  yystos[*yyssp], yyvsp, yylsp);
      YYPOPSTACK (1);
    }
#ifndef yyoverflow
  if (yyss != yyssa)
    YYSTACK_FREE (yyss);
#endif
#if YYERROR_VERBOSE
  if (yymsg != yymsgbuf)
    YYSTACK_FREE (yymsg);
#endif
  /* Make sure YYID is used.  */
  return YYID (yyresult);
}



/* Line 1684 of yacc.c  */
#line 2363 "hlsl.y"


static void set_location(struct source_location *loc, const struct YYLTYPE *l)
{
    loc->file = hlsl_ctx.source_file;
    loc->line = l->first_line;
    loc->col = l->first_column;
}

static DWORD add_modifier(DWORD modifiers, DWORD mod, const struct YYLTYPE *loc)
{
    if (modifiers & mod)
    {
        hlsl_report_message(hlsl_ctx.source_file, loc->first_line, loc->first_column, HLSL_LEVEL_ERROR,
                "modifier '%s' already specified", debug_modifiers(mod));
        return modifiers;
    }
    if (mod & (HLSL_MODIFIER_ROW_MAJOR | HLSL_MODIFIER_COLUMN_MAJOR)
            && modifiers & (HLSL_MODIFIER_ROW_MAJOR | HLSL_MODIFIER_COLUMN_MAJOR))
    {
        hlsl_report_message(hlsl_ctx.source_file, loc->first_line, loc->first_column, HLSL_LEVEL_ERROR,
                "more than one matrix majority keyword");
        return modifiers;
    }
    return modifiers | mod;
}

static void dump_function_decl(struct wine_rb_entry *entry, void *context)
{
    struct hlsl_ir_function_decl *func = WINE_RB_ENTRY_VALUE(entry, struct hlsl_ir_function_decl, entry);
    if (func->body)
        debug_dump_ir_function_decl(func);
}

static void dump_function(struct wine_rb_entry *entry, void *context)
{
    struct hlsl_ir_function *func = WINE_RB_ENTRY_VALUE(entry, struct hlsl_ir_function, entry);
    wine_rb_for_each_entry(&func->overloads, dump_function_decl, NULL);
}

struct bwriter_shader *parse_hlsl(enum shader_type type, DWORD major, DWORD minor,
        const char *entrypoint, char **messages)
{
    struct hlsl_scope *scope, *next_scope;
    struct hlsl_type *hlsl_type, *next_type;
    struct hlsl_ir_var *var, *next_var;
    unsigned int i;

    hlsl_ctx.status = PARSE_SUCCESS;
    hlsl_ctx.messages.size = hlsl_ctx.messages.capacity = 0;
    hlsl_ctx.line_no = hlsl_ctx.column = 1;
    hlsl_ctx.source_file = d3dcompiler_strdup("");
    hlsl_ctx.source_files = d3dcompiler_alloc(sizeof(*hlsl_ctx.source_files));
    if (hlsl_ctx.source_files)
        hlsl_ctx.source_files[0] = hlsl_ctx.source_file;
    hlsl_ctx.source_files_count = 1;
    hlsl_ctx.cur_scope = NULL;
    hlsl_ctx.matrix_majority = HLSL_COLUMN_MAJOR;
    list_init(&hlsl_ctx.scopes);
    list_init(&hlsl_ctx.types);
    init_functions_tree(&hlsl_ctx.functions);

    push_scope(&hlsl_ctx);
    hlsl_ctx.globals = hlsl_ctx.cur_scope;
    declare_predefined_types(hlsl_ctx.globals);

    hlsl_parse();

    if (TRACE_ON(hlsl_parser))
    {
        TRACE("IR dump.\n");
        wine_rb_for_each_entry(&hlsl_ctx.functions, dump_function, NULL);
    }

    TRACE("Compilation status = %d\n", hlsl_ctx.status);
    if (messages)
    {
        if (hlsl_ctx.messages.size)
            *messages = hlsl_ctx.messages.string;
        else
            *messages = NULL;
    }
    else
    {
        if (hlsl_ctx.messages.capacity)
            d3dcompiler_free(hlsl_ctx.messages.string);
    }

    for (i = 0; i < hlsl_ctx.source_files_count; ++i)
        d3dcompiler_free((void *)hlsl_ctx.source_files[i]);
    d3dcompiler_free(hlsl_ctx.source_files);

    TRACE("Freeing functions IR.\n");
    wine_rb_destroy(&hlsl_ctx.functions, free_function_rb, NULL);

    TRACE("Freeing variables.\n");
    LIST_FOR_EACH_ENTRY_SAFE(scope, next_scope, &hlsl_ctx.scopes, struct hlsl_scope, entry)
    {
        LIST_FOR_EACH_ENTRY_SAFE(var, next_var, &scope->vars, struct hlsl_ir_var, scope_entry)
        {
            free_declaration(var);
        }
        wine_rb_destroy(&scope->types, NULL, NULL);
        d3dcompiler_free(scope);
    }

    TRACE("Freeing types.\n");
    LIST_FOR_EACH_ENTRY_SAFE(hlsl_type, next_type, &hlsl_ctx.types, struct hlsl_type, entry)
    {
        free_hlsl_type(hlsl_type);
    }

    return NULL;
}

